#!/usr/bin/env python
import sys
import os
import dfont
import dsans as dhint
from dcmd import *


txt = ""

cvt_dict = {
    "w_1337":           57,     #1337
    "w_1290":           127,    #1290
    "w_1231":           75,     #1231
    "w_1180":           73,     #1180
    "w_1133":           60,     #1133
    "w_1120":           200,    #1120
    "w_1112":           228,    #1112
    "w_1081":           71,     #1081
    "w_1051":           225,    #1051
    "w_1024":           138,    #1024
    "w_973":            178,    #973
    "w_926":            275,    #926
    "w_866":            286,    #866
    "w_569":            58,     #569
    "w_522":            108,    #522
    "w_455":            109,    #455
    "w_397":            45,     #397
    "w_385":            44,     #385
    "w_307":            1,      #307
    "w_291":            87,     #291
    "w_264":            271,    #264
#
    "w_236":            159,    #236
    "w_213":            102,    #213
    "w_195":            144,    #195
    "w_172":            16,     #172
    "w_154":            85,     #154
    "w_139":            238,    #139
#
    "base":             10,     #0
    "hstem":            13,         #358
    "hstem_curve":      144,        #195    =big curve hstem
    "hstem_thin":       54,         #246
#
    "vstem_236":        159,        #236    =3 spline, thinner
    "vstem_curve":      159,        #236    =3 spline, thinner
    "vstem_258":        161,        #258    =2 spline, thicker
    "vstem_thin":       85,         #154
    "vstem_small":      221,        #133 
    "vstem_tiny":       124,        #152
#
    "headstem":         30,         #127
    "headstem_plus_hole":   301,    #279
    "headstem_small":   36,         #113    =kho
    "headstem_small_plus_hole":   271,          #264
    "headstem_tiny":    158,        #106
    "headstem_tiny_plus_hole":    4,            #233
    "headstem_wan":     260,    #60
    "headstem_big":     16,     #172
    "headstem_sara":    59,     #88
    "headstem_sara_plus_hole":    94,    #193
    "sarastem":         30,         #127
#
    "headdia":          298,        #406
    "headdia_small":    198,        #377    =kho
    "headdia_tiny":     24,         #340
    "headdia_sara":     91,         #281
    "headhole":         131,        #152    
    "headneck_kho":     39,     #180    =kho
#
    "hwidth_a":         61,     #1085   =a
    "hwidth_ching":     275,    #926    =cho_ching
#
    "hnext_1":          58,         #569    =next spline of sho_sher
#
    "vheight":          179,        #1120   =normal height 
    "vheight_shoot":    202,        #1147   =overshoot height
    "vheight_hi":       49,     #1208   =ko 
    "vheight_hi_kho":   47,     #1204   =kho 
    "vheight_po":       163,        #1556   =po_pla, fo_fa
    "vheight_o":        197,        #1638   =sara_o, sara_i
    "vheight_lo":       152,        #29 
    "vheight_lu":       98,         #410    =lo_lu
    "vheight_below_do": 98,     #410
    "vheight_num":      275,        #926
    "vheight_sara1":    127,        #1290
#
    "head_diff":        131,    #254    =head of character: bo,po
    "beak_diff":        148,    #84     =beak of ko,tho
    "beak_diff_2":      38,     #340    =beak of ko,tho
#
    "front_001":        7,          #162
#
    "front_kai":        59,         #88     =front spacing of ko_kai
    "front_khai":       262,        #20     =front spacing of kho_khai
    "front_dek":        30,         #127
    "front_thahan":    38,         #37
#
    "front_khuad":      157,    #451    =front spacing of kho_khud
    "front_tahan":      38,     #340    =front spaceing of to_tahan
    "front_dek":        106,    #213    =front spaceing of do_dek
    "front_thong":      79,     #229    =front spaceing of to_thong
    "front_pung":       228,    #174    =front spaceing of po_pung
    "front_pan":        31,     #330    =front spacing of do_chada, po_pan
    "front_ma":         180,    #377    =front spaceing of mo_ma
    "front_ling":       1,      #184    =front spaceing of lo_ling, aw_ang
#
#special
    "special_1":        230,    #45
    "special_2":        88,     #20
#gap
    "gap_20":           262,    #20
    "gap_88":           59,     #88
    "gap_113":          36,     #113
    "gap_143":          129,    #143
    "gap_162":          7,      #162
    "gap_r_ko":         7,      #162
    "gap_172":          16,     #172
    "gap_f_ko":         16,     #172
    "gap_186":          41,     #186
    "gap_195":          144,    #195
    "gap_236":          159,    #236
}


#----------------------------------------
#   code
#----------------------------------------
def gedit(txt,gen_pseudo=False):
    """invoke gedit"""
    os.system('killall gedit')
    if gen_pseudo:
        f = open('xcode.txt','w')
        #strip blank line
        lt = [i.strip() for i in txt.split('\n')]
        txt = '\n'.join([i for i in lt if i])
        f.write(txt)
        f.close()
        os.system('gedit xcode.txt &')
    f = open('x.txt','w')
    f.write('\n'.join(dfont.inst_encode(txt, cvt_dict )))
    f.close()
    os.system('gedit x.txt &')
    return


#----------------------------------------
def v_end_front_spline(s0,s1):
    return """
SRP0                %s          #s0
MDRP[rp0,rnd,grey]  %s          #s1
MDRP[grey]          %s          #s1+1
#ay#SHPIX           -24 %s      #s1+1
""" % (s0,s1,s1+1,s1+1,)


#----------------------------------------

def h_reduce_head(s2,headtype="tho_thung",s1=-1):
    turn_right_dstr = "12-4 13-4 21-8 22-8 "
    turn_left_dstr = "12+4 13+4 21+8 22+8 "
    round_tr_dstr= "19-8 24-8 25-8 30-8 "  #for round 384pt
    round_tl_dstr= "19+8 24+8 25+8 30+8 "  #for round 384pt
    dry11 = "14-6 15-5 16-4 "
    dry12 = "14-3 15-3 16-3 "
    dry21 = "14+6 15+5 16+4 "
    dry22 = "14+3 15+3 16+3 "

    #------head turn right : forward--------------------
    if headtype in ["tho_thung","sara_e"]: 
        if headtype == "sara_e":    #reverse direction
            t = s1
            s1 = s2
            s2 = t
        return \
        f_dstr(s2,turn_right_dstr) + \
        f_dstr_dict({
            s2+2:dry11,
            s2-2:dry11 }, aip="#ax#")
    elif headtype == "pho_phung": return \
        f_dstr(s2,turn_right_dstr + "16-8 30-8 39-8 ") +\
        f_dstr_dict({
            s2+2:dry11,
            s2-2:dry11 }, aip="#ax#")
    elif headtype == "kho_khwai": return \
        f_dstr_dict({
            s1:"14+2 15+2 16+2 ",
            s2:"13-8 14-1 15-1 16-1 18-8 19-8 23-8 24-8 25-8 28-8 29-8 30-8 33-8" }) + \
        f_dstr_dict({
            s2+2:dry11,
            s2-2:dry11 }, aip="#ax#")
    elif headtype == "no_nu": return \
        f_dstr_dict({
            s2-2:dry22,
            s1-2:dry12,
            s1+2:dry12 }, aip="#ax#")
    elif headtype == "yo_yak": return \
        f_dstr(s2,"9-8 10-8 25-8 30-8") +\
        f_dstr_dict({
            s2+2:dry21,
            s2-2:dry11 }, aip="#ax#")
    elif headtype == "thai_digit_three": return \
        f_dstr(s2,"10-8 11-4 14-8 22-8 ") + \
        f_dstr_dict({
            s2+2:dry11,
            s2-2:dry11 }, aip="#ax#")
    elif headtype == "thai_digit_four": return \
        f_dstr(s2,"9-8 13-8 ") + \
        f_dstr_dict({
            s2+2:dry11,
            s2-2:dry11 }, aip="#ax#")
#    #------head turn right : reverse--------------------
#    elif headtype == "sara_e": return \
#        f_dstr(s1,"12-4 13-4 21-8 22-8 ") +\
#        f_dstr_dict({
#            s1+2:dry11,
#            s1-2:dry11 }, aip="#ax#")
    #------head turn left------------------------------
    elif headtype in ["tho_thahan","ngo_ngu"]: 
        if headtype == "ngo_ngu":    #reverse direction
            t = s1
            s1 = s2
            s2 = t
        return \
        f_dstr(s1,turn_left_dstr) + \
        f_dstr_dict({
            s1+2:dry21,
            s1-2:dry21 }, aip="#ax#")
    elif headtype == "cho_chan": return \
        f_dstr(s1,"12+4 13+4 21+8 22+8 25+8 30+8 34+8 ") + \
        f_dstr_dict({
            s1+2:dry11,
            s1-2:dry11 }, aip="#ax#")
    elif headtype == "mo_ma": return \
        f_dstr_dict({
            s2+2:dry21,
            s2-2:dry21 }, aip="#ax#")
    elif headtype == "cho_choe": return \
        f_dstr_dict({
            s1+2:dry21,
            s1-2:dry22,
            s2+2:dry12 }, aip="#ax#")
    elif headtype == "do_dek": return \
        f_dstr_dict({
            s1:"14+1 15+1 16+1 ",
            s2:"14-1 15-1 16-1 19-8 24-8 25-8 30-8 " }) + \
        f_dstr_dict({
            s1+2:dry22,
            s1-2:dry22,
            s2-2:dry12 }, aip="#ax#")
    elif headtype == "kho_khai": return \
        f_dstr_dict({
            s1:"14+1 15+1 16+1 ",
            s2:"14-1 15-1 16-1 19-8 20-8 24-8 25-8 30-8 35-8 40-8 41-8 " }) + \
        f_dstr_dict({
            s1-2:dry22,
            s1+2:dry12,
            s2-2:dry11 }, aip="#ax#")
    elif headtype == "kho_khuat": return \
        f_dstr_dict({
            s1:"14+1 15+1 16+1 ",
            s2:"9-8 10-8 13-8 14-1 15-1 16-1 18-8 19-8 20-8 23-8 24-8 25-8 28-8 29-8 33-8 34-8 " }) + \
        f_dstr_dict({
            s1-2:dry22,
            s1+2:dry12,
            s2-2:dry11 }, aip="#ax#")
    elif headtype == "ho_hip": return \
        f_dstr_dict({
            s2+2:dry22,
            s2-2:dry12,
            s1-2:dry12 }, aip="#ax#")
    #------other------------------------------
    elif headtype == "sara_a": return \
        f_dstr(s2,"24-8 25-8 ") + \
        f_dstr_dict({
            s1+2:dry22,
            s2-2:dry12,
            s2+2:dry11 }, aip="#ax#")
    elif headtype == "thai_digit_one": return \
        f_dstr(s2,"9+8 10+8 "+round_tl_dstr) + \
        f_dstr_dict({
            s2+2:dry22,
            s1-2:dry12,
            s1+2:dry11 }, aip="#ax#")
    elif headtype == "mai_hanakat": return \
        f_dstr_dict({
            s2:"9-8 10-8 14+3 15+5" }) + \
        f_dstr_dict({
            s1+2:"16+3 ",
            s2-2:"16-3 ",
            s2+2:"16-6 "}, aip="#ax#")
    elif headtype == "sara_u":  return \
        ""
    else:
        raise "h_reduce_head"


#----------------------------------------

def v_reduce_head(s2, headtype="top_down", s1=-1):
    #-----hint down------------------------------
    if headtype == "top_down":  #ngo_ngu
        return f_dstr(s2,"9+8 10+8 14+1 15+1 16+1 19+8 24+8 25+8 30+8 ")
    elif headtype == "sara_a_top_down":
        return f_dstr(s2,"21+8 30+8 ")
    elif headtype == "sara_a_bottom_up": #***
        return f_dstr(s2,"21-8 30-8 ")
    elif headtype == "mai_hanakat": #***
        return f_dstr(s2,"13-8 19-8 29-8 ")
    elif headtype == "thai_digit_six": #***
        return f_dstr(s2,"12-8 21-8 ")
    elif headtype == "thai_digit_nine": #***
        return f_dstr(s2,"12-8 17-8 22-8 ")
    elif headtype == "thai_digit_eight": #***
        return f_dstr(s2,"10-8 14-8 18-8 22-8 26-8 30-8 34-8 38-8 ")
    elif headtype == "kho_khai": #kho_khai
        return f_dstr(s2,"9+8 10+8 14+1 15+1 16+1 20+8  25+8 ")
    elif headtype == "kho_khuat":
        return f_dstr(s2,"9+8 10+8 14+1 15+1 16+1 19+8 20+8  24+8 25+8 ")
    elif headtype == "middle_down": #cho_chan
        return f_dstr_dict( {
            s1:"14-1 15-1 16-1 20-1 21-1 22-1 ",
            s2:"9+8 10+8 14+1 15+1 16+1 19+8  20+1 21+1 22+1 24+8  25+8 30+8 " })
    elif headtype == "thai_digit_four":
        return f_dstr(s2,"")
    #-----hint up------------------------------
    elif headtype == "bottom_up":   #tho_thung
        return f_dstr(s2,"9-8 10-8 14-1 15-1 16-1 19-8  24-8  25-8 30-8 ")
    #-----special-----
    elif headtype == "sara_u":
        return f_dstr(s2,"10+8 ")
    else:
        raise "value of headtype=%s not exist in v_reduce_head" % (headtype,)


#------------------------------------------------
def h_shift(s1, shift):
    return """
SHPIX                   %s    %s
""" % (shift, s1)

def dry_1(s):
    return """
SHPIX           -16 %s
SHPIX           -16 %s
""" % (s+2,s-2,)

def dry_2(s):
    return """
SHPIX           16 %s
SHPIX           16 %s
""" % (s+2,s-2,)


def exp_head_1(s1):
    return h_shift(s1, -16)

def exp_head_2(s1):
    return h_shift(s1, 16)

def h_exp_head(s1,s2,headtype=""):
    if headtype == "sara_u":
        return ""
    else:
        return f_dstr_dict({
            s1:"19-1 20-1 21-1 22-1 23-2 24-2 25-2",
            s2:"19+1 20+1 21+1 22+1 23+2 24+2 25+2"})


def h_exp_head_1(s1,s2):
    return """
f_deltap    %s 20+1 %s 21+1 %s 22+1 %s 23+2 %s 24+2 %s 25+2
%s          #h_shift(s1, -12)
""" % tuple((s2,)*6 + (h_shift(s1,-12),))

def h_exp_head_2(s1,s2):
    return """
f_deltap    %s 20-1 %s 21-1 %s 22-1 %s 23-2 %s 24-2 %s 25-2
%s          #h_shift(s2, 12)
""" % tuple((s1,)*6 + (h_shift(s2,12),))

#------------------------------
def v_exp_head(s1,s2,headtype=""):
    if headtype[:7] in ["sara_a_"]:
        temp = "\nSHPIX     -12 %s\n" % (s2,)
    else:
        temp = ""
    return f_dstr_dict({
        s1:"20+1 21+1 22+1 23+1 24+1 25+1",
        s2:"20-1 21-1 22-1 23-1 24-1 25-1"
        }) + temp

def groove_1(s1):
    return h_shift(s1, -24)

def groove_2(s1):
    return h_shift(s1, 24)

def dx_1(s1):
    return h_shift(s1, -8)

def dx_2(s1):
    return h_shift(s1, 8)

def notch_1(s1):
    return h_shift(s1, -16)

def notch_2(s1):
    return h_shift(s1, 16)



#------------------------------------------------
def hstem_1(s1,move_rp0=False):
    if move_rp0:
        return """
MIRP[rp0,min,rnd,grey]  hstem %s        #s1
""" % (s1,)
    else:
        return """
MIRP[min,rnd,grey]      hstem %s        #s1
""" % (s1,)

#....................
def hstem1(s1):
    return hstem_1(s1,move_rp0=False)

def hstem1m(s1):
    return hstem_1(s1,move_rp0=True)

#------------------------------------------------
def head_0(s2, li, add2="", add3="",move_rp0=False):
    if move_rp0:
        mrp = "rp0,"
    else:
        mrp = ""
    return """
MDRP[%srnd,grey]        %s              #mrp,s2    %s  #add2
%s          #f_ip(li)   %s  #add3
""" % (mrp,s2,add2, f_ip(li),add3)


#....................

def h_head(s1, s2, li, move_rp0=True, headtype="tho_thahan"): #cho_ching
    add2 = h_reduce_head(s2,headtype=headtype,s1=s1)
    #expand head hole
    if headtype in ["kho_khuat","kho_khwai","pho_phung","tho_thung","no_nu","yo_yak","sara_e"]:
        add3 = h_exp_head_1(li[0],li[1])
    elif headtype in ["sara_a","thai_digit_four"]:    #sara_a, paiyalnoi
        add3 = h_exp_head(li[0],li[1],headtype)
    else:
        add3 = h_exp_head_2(li[0],li[1])
    #move rp0
    if headtype in ["no_nu"]:
        move_rp0 = False
    return head_0(s2, li, add2,add3, move_rp0)

    

#....................
def v_head(s1,s2,li, headtype="top_down",move_rp0=False):
    add2 = v_reduce_head(s2,headtype=headtype,s1=s1)
    add3 = v_exp_head(li[0],li[1],headtype=headtype)
    return head_0(s2, li, add2,add3,move_rp0)

#....................


def head0(s2, li,move_rp0=False):   #simple, no expand hole, no reduce head
    add2 = ""
    return head_0(s2, li,add2=add2,move_rp0=move_rp0)


def head0s(s2,s2s, li):
    add2 = ""
    add3 = ""
    return head_0(s2, li,add2)


#..............................
def head01(s2, li, add2="", move_rp0=False):   #expand hole down
    add3 = """
%s                                      #exp_head_1(li[1])
""" % (exp_head_1(li[1]),)
    return head_0(s2, li, add2,add3, move_rp0)

def head01m(s2, li, add2="", move_rp0=True):
    return head01(s2, li, add2, move_rp0)


def head011(s2, li, move_rp0=False):   #expand hole down, reduce head down
    add2 = """
f_deltap                 %s 16-8  %s 30-8       #s2
""" % (s2,s2,)
    return head01(s2, li, add2, move_rp0)

def head011m(s2, li, move_rp0=True):
    return head011(s2, li, move_rp0)

def head012(s2, li, move_rp0=False):   #expand hole down, reduce head down
    add2 = """
f_deltap                 %s 16+8  %s 30+8       #s2
""" % (s2,s2,)
    return head01(s2, li, add2, move_rp0)

def head012m(s2, li, move_rp0=True):
    return head012(s2, li, move_rp0)


#..............................
def head02(s2, li, add2="", move_rp0=False):   #expand hole down
    add3 = """
%s                                      #exp_head_2(li[1])
""" % (exp_head_2(li[1]),)
    return head_0(s2, li, add2,add3, move_rp0)

def head02m(s2, i121,i122, move_rp0=True):
    move_rp0 = True
    return head02(s2, i121,i122, add2="", move_rp0=move_rp0)

#....................
def head11(s2, li, move_rp0=False):   #expand hole down, reduce head down
    add2 = """
f_deltap                 %s 11-8  %s 12-8       #s2
""" % (s2,s2,)
    return head01(s2, li, add2, move_rp0)


def head21(s2, li, move_rp0=False):   #expand hole down, reduce head up 
    add2 = """
f_deltap                 %s 11+8  %s 12+8       #s2
""" % (s2,s2,)
    return head01(s2, li, add2, move_rp0)




#------------------------------------------------
def vstem_0c(s1,stem="vstem_curve",thin=0, type="+"):
#    if thin == 2:   #kho_khwai
#        temp = f_dstr(s1,"9-1 10-1 11-1 12-1 13-1 14-1 15-1 16-1 17-3 18+3 19+2 20+2 21+1 22+1 ",type=type)
#    elif thin == 1: #cho_chan
#        temp = f_dstr(s1,"9-1 10-1 11-1 12-1 13-1 14-1 15-1 16-1 17-4 18+3 19+2 20+2 21+1 22+1 ",type=type)
#    else:           #ko_kai
#        temp = f_dstr(s1,"9-2 10-2 11-2 12-2 13-2 14-2 15-2 16-2 17-4 18+2 19+1 20+1 ",type=type)
#
#    return """
#MIRP[min,rnd,grey]      %s %s           #stem,s1
#SHPIX                   %s24 %s         #type,s1
#%s      #delta vstem
#""" % (stem, s1, type.replace('+',' '),s1, temp,)
    temp = f_dstr(s1,"16+4 ")
    return """
MIRP[min,rnd,grey]      %s %s           #stem,s1
#SHPIX                   %s24 %s         #type,s1
#%s      #delta vstem
""" % (stem, s1, type.replace('+',' '),s1, temp,)

#....................
def vstem_c1(s1,thin=0):
    return vstem_0c(s1,thin=thin)

def vstem_c1s(s1,s1s):
    return vstem_c1(s1) + """
SHP[rp2]                %s                  #s1s
""" % (s1s)

def vstem_c_bottom(s1):
    return vstem_0c(s1,type="-")

def vstem_cs_bottom(s1,s1s):
    return vstem_c_bottom(s1) + """
SHP[rp2]            %s                  #s1s
""" % (s1s,)

def vstem_c2s(s1,s1s):
    return vstem_c2(s1) + """
SHP[rp2]                %s                  #s1s
""" % (s1s)

#------------------------------------------------
def vstem_b1(s1,stem="vstem_line"):
    return """
MIRP[min,rnd,grey]      %s %s               #stem,s1
SHPIX                   -24 %s              #s1
f_deltap        %s 9+2  %s 10+2  %s 11+2  %s 12+2 %s 13+2 %s 14+2 %s 15+2 %s 16+2 %s 17+5 %s 18-3 %s 19-2 %s 20-1
""" % tuple((stem,) + (s1,)*14)

def vstem_b2(s1,stem="vstem_line",thin=False):
    if thin:
        temp = """
SHPIX                   36 %s               #s1
""" % (s1,)
    else:
        temp = """
SHPIX                   24 %s               #s1
""" % (s1,)
    return """
MIRP[min,rnd,grey]      %s %s               #stem,s1
%s      #temp
f_deltap        %s 9-2  %s 10-2  %s 11-2  %s 12-2 %s 13-2 %s 14-2 %s 15-2 %s 16-2 %s 17-5 %s 18+3 %s 19+2 %s 20+1
""" % tuple((stem,) + (s1,) + (temp,) + (s1,)*12)

#....................
def vstem_b1s(s1,s1s):
    return vstem_b1(s1) + """
SHP[rp2]                %s                  #s1s
""" % (s1s)

#..............................
def vstem_1_1(s1,sign="-"):
    return """
MDRP[grey]              %s                   #s1
SHPIX                   %s16 %s              #sign,s1
""" % (s1,sign,s1,)

def vstem_11(s1):
    return vstem_1_1(s1,sign="-")

def vstem_12(s1):
    return vstem_1_1(s1,sign=" ")

def f_stem(s1,s2,stem,type="+",move_rp0=False,thin=False):
    #dstr="9+4 10+4 11+4"
    if stem in ['v_kho_khai']:
        dstr = "9-5 10-4 11-4 12-3 13-3 14-2 15-2 16-2"
    else:
        raise "error in f_stem value of dstr mismatch"
    fstr = f_dstr(s2,type=type)

    if move_rp0:
        mrp = "rp0,"
    else:
        mrp = ""

    if stem[0] == "v":
        rnd = ""
    else:
        rnd = "rnd,"

    if thin:
        fstr += """
SHPIX           %s8 %s
""" % (type.replace('+','*').replace('-',' ').replace('*','-'),s2,)

    return """
MDRP[%smin,%sgrey]      %s       #mrp,rnd,s2
%s      #fstr
""" % (mrp, rnd, s2, fstr)



#------------------------------------------------
#dhint.hf_0
#....................
def hf_ngo_ngu(s0,s1,g1=""):
    add1 = """
f_deltap            %s 9-8
""" % (s1,)
    return dhint.hf_0(s0,s1,add1,g1)


def hf_wo_waen(s0,s1, g1="gap_51"):
    return dhint.hf_0(s0,s1,g1=g1)


def hf_ro_rua(s0,s1,s2,g1="gap_84"):
    add1 = """
MDRP[grey]              %s              #s2
SHPIX                   -24 %s          #s2
""" % (s2,s2,)
    return dhint.hf_0(s0,s1,add1,g1)


def hf_kho_khai(s0,s1,s2,li,g1="gap_51"):
    add1 = """
f_deltap    %s 9-8 %s 10-8 %s 11-8 %s 12-8 %s 13-8 %s 14-8 %s 17-8 %s 18-8
%s          #h_head(s1,s2,li,headtype="kho_khai")
SHPIX                   -16 %s
""" % tuple((s1,)*8 + (h_head(s1,s2,li,headtype="kho_khai"),li[2],))
    return dhint.hf_0(s0,s1,add1,g1)


def hf_kho_khuat(s0,s1,s2,li,g1="gap_51"):
    add1 = """
f_deltap    %s 9-8 %s 10-8 %s 11-8 %s 12-8 %s 13-8 %s 14-8 %s 15-8 %s 17-8 %s 18-8
%s          #h_head(s1,s2,li,headtype="kho_khuat")
SHPIX                   -16 %s
""" % tuple((s1,)*9 + (h_head(s1,s2,li,headtype="kho_khuat"),li[2],))
    return dhint.hf_0(s0,s1,add1,g1)


def hf_paiyannoi(s0,s1,s2,li,g1="gap_113"):
    add1 = """
f_deltap    %s 9-8
%s          #h_head(s1,s2,li,headtype="sara_a")
SHPIX                   -16 %s
""" % tuple((s1,)*1 + (h_head(s1,s2,li,headtype="sara_a"),li[2],))
    return dhint.hf_0(s0,s1,add1,g1)


def hf_maiyamok(s0,s1,s2, li, g1="gap_113"):
    add1 = """
%s          #h_head(s1,s2,li,headtype="kho_khuat")
SHPIX                   -16 %s
""" % (h_head(s1,s2,li,headtype="kho_khuat"),li[2],)
    return dhint.hf_0(s0,s1,add1,g1)


def hf_tho_thong(s0,s1,t1, s2,s3, g1="gap_84"):
    add1 = """
f_deltap                %s 9-8 %s 10-8  %s 11-8 %s 12-8 %s 13-8 %s 14-8
MDRP[grey]              %s              #t1
SHPIX                   -16 %s          #t1
MDRP[rp0,min,rnd,grey]  %s              #s2
MIRP[min,rnd,grey]      hstem %s        #s3
""" % tuple((s1,)*6 + (t1,)*2 + (s2, s3))
    return dhint.hf_0(s0,s1,add1,g1)


#------------------------------------------------
#dhint.hf_ko_kai
#....................
def hf_ko_kai(s0,s1, s2,s3, s4, s5,s6, g1="gap_f_ko"):
    add1 = """
f_deltap    %s 14+8 %s 15+8 %s 16+8
""" % (s1,s1,s1,)
    #add3 = groove_1(s3)
    #add6 = groove_2(s6)
    add3 = groove_2(s3)
    add6 = groove_1(s6)
    return dhint.hf_ko_kai(s0,s1,s2,s3,s4, s5,s6,add1, add3, add6, g1)


def hf_tho_thung(s0,s1, s2,s3, s4, s5,s6, s7, li):
    return hf_ko_kai(s0,s1, s2,s3, s4, s5,s6) + """
SRP0                    %s              #s1
%s          #h_head(s1,s7,li,headtype="tho_thung")
""" % (s1, h_head(s1,s7,li,headtype="tho_thung"),)


#----------------------------------------
def hf_2(s0,s1, s2, li, add1="", add2="", g1="gap_84"): #tho_no_cho_bo
    add1 = """
f_deltap    %s 9-8  %s 12-8  %s 13-8  %s 21-8 %s 22-8    #s1
""" % tuple((s1,)*5) + add1
    return dhint.hf_0(s0,s1,add1,g1) + """
%s          #h_head(s1,s2,li,headtype="tho_thahan")     %s  #add2
""" % (h_head(s1,s2,li,headtype="tho_thahan"), add2,)

    
#..............................
def hf2_1(s0,s1,s2,li,s3, add1="", add2="", add3="", move_rp0=False):
    if move_rp0:
        temp = "rp0,"
    else:
        temp = ""
    add2 = add2 + """
MIRP[%smin,rnd,grey]      hstem %s        #s3   %s  #add3
""" % (temp,s3,add3)
    return hf_2(s0,s1,s2,li,add1,add2)


def hf2s_1(s0,s1,s2,s2s, li,s3, add1="",add2="",add3="", move_rp0=False):
    add2 = add2 + """
ALIGNRP                 %s              #s2s
""" % (s2s,)
    return hf2_1(s0,s1,s2,li,s3, add1, add2, add3, move_rp0)


#....................
def hf_pho_phan(s0,s1,s2,li,s3):
    return hf2_1(s0,s1,s2,li,s3)


#....................
def hf_tho_thahan(s0,s1, s2,s2s, li, s3):
    return hf2s_1(s0,s1, s2,s2s, li, s3)


def hf_cho_ching(s0,s1,t1, s2,s2s, li, s3,add1="",add2=""):  #hf2_1
    add2 = """
MDRP[rnd,grey]          %s              #t1
""" % (t1,)
    return hf2s_1(s0,s1, s2, s2s, li, s3, add1,add2)


def hf_mo_ma(s0, s1,s1s, s2,s2s, li, s3):
    add1 = """
f_deltap    %s 10-8
""" % (s1,)
    add2 = ""
    return hf2s_1(s0,s1, s2,s2s, li, s3, add1=add1, add2=add2) + """
SRP0                    %s              #s1
ALIGNRP                 %s              #s1s
SRP0                    %s              #li[0]
ALIGNRP                 %s              #li[2]
SRP0                    %s              #li[1]
ALIGNRP                 %s              #li[3]
%s      #h_reduce_head(s1s,headtype="mo_ma")
""" % (s1,s1s,li[0],li[2],li[1],li[3],h_reduce_head(s1s,headtype="mo_ma"),)


def hf_bo_baimai(s0,s1, s2, li, s3, s4):     #hf2_2
    add1 = add2 = ""
    add3 = """
MDRP[rnd,grey]          %s              #s4
""" % (s4,)
    return hf2_1(s0,s1, s2, li, s3, add1, add2, add3, move_rp0=True)


def hf_so_rusi(s0,s1, s2, li2, s3, s4, s5, s6, li6):     #hf2_2
    add1 = add2 = ""
    add3 = """
MDRP[rnd,grey]          %s              #s4
SRP0                    %s              #s2
MDRP[rp0,grey]          %s              #s5
MDRP[grey]              %s              #s6
%s          #f_ip(li6)
""" % (s4,s2,s5,s6, f_ip(li6),)
    return hf2_1(s0,s1, s2, li2, s3, add1, add2, add3, move_rp0=True)


#------------------------------------------------


#------------------------------------------------
def hf_pho_samphao(s0,s1,s2,li2, s3,s4, s5, s6,s7,g1="gap_84"):
    return """
SRP0                    %s              #s0
MIRP[rp0,rnd,white]     %s %s           #g1,s1
f_deltap    %s 9-8  %s 12-8  %s 13-8 #s1
%s          #h_head(s1,s2,li2)
MDRP[rp0,grey]          %s              #s3
MDRP[grey]              %s              #s4
SRP0                    %s              #s2
MIRP[rp0,min,rnd,grey]  hstem %s        #s5
MDRP[rp0,grey]          %s              #s6
MDRP[grey]              %s              #s7
%s          #groove_1(s7) 
%s          #groove_2(s4) 
""" % (s0,g1,s1, s1,s1,s1, h_head(s1,s2,li2), s3,s4, s2,s5,s6,s7,groove_1(s7),groove_2(s4),)

#----------------------------------------
def hf_5(s0,s1, s2,s3, li,add1="",add2="", g1="gap_113"):    #cho_chan
    return """
SRP0                    %s          #s0
MIRP[rp0,rnd,grey]      %s %s       #g1,s1  %s  #add1
MDRP[rp0,rnd,grey]      %s          #s2       
%s          #h_head(s2,s3,li,headtype="cho_chan")    %s  #add2
""" % (s0,g1,s1,add1, s2,h_head(s2,s3,li,headtype="cho_chan"),add2)

#....................
def hf_cho_chan(s0,s1, s2,s3, li):
    add1 = """
f_deltap    %s 9-8 %s 10-8
""" % (s1,s1,)
    add2 = """
f_deltap    %s 16-7 %s 17-4  %s 16-4 %s 17-2
""" % (s3,s3, li[1],li[1],)
    return hf_5(s0,s1, s2,s3, li,add1,add2)


def hf_tho_than(s0,s1,t1, s2,s3, li):
    add1 = """
f_deltap    %s 9-8 %s 10-8
MDRP[grey]          %s              #t1
SHPIX               -16 %s          #t1
""" % (s1,s1,t1,t1,)
    add2 = ""
    return hf_5(s0,s1, s2,s3, li,add1,add2)


#----------------------------------------
def hf_6(s0,s1, s2, add1="",add2="", g1="gap_143"):  #pho_phung
    return """
SRP0                    %s          #s0
MIRP[rp0,rnd,white]     %s %s       #g1,s1  %s  #add1
MIRP[min,rnd,grey]      hstem %s    #s2     %s  #add2
""" % (s0, g1,s1,add1, s2,add2,)


#....................
def hf_pho_phung(s0,s1, s2,s2s, s3, li, g1="gap_164"):
    add1 = ""
    add2 = """
SHP[rp2]                %s              #s2s
%s          #h_head(s1,s3,li,headtype="pho_phung")
""" % (s2s,h_head(s1,s3,li,headtype="pho_phung"),)
    return hf_6(s0,s1, s2, add1,add2, g1=g1)


def hf_lo_ling(s0,s1, s2, t2, s3, li,add1="",add2="",g1="gap_113"):
    add1 = """
f_deltap        %s 9-8 
""" % (s1,)
    add2 = """
MDRP[rnd,grey]          %s              #t2
%s          #h_head(s1,s3,li,headtype="tho_thung"))
""" % (t2, h_head(s1,s3,li,headtype="tho_thung"))
    return hf_6(s0,s1, s2, add1,add2,g1)

def hf_o_ang(s0,s1, s2, t2, s3, li,g1="gap_143"):
    add1 = """
f_deltap                %s 9-8          #s1
""" % (s1,)
    return hf_lo_ling(s0,s1, s2, t2, s3, li, add1=add1)

def hf_ho_nokhuk(s0,s1, s2, t2,t3, s3, li, g1="gap_143"):
    add1 = """
f_deltap                %s 9-8          #s1
""" % (s1,)
    add2 = """
MDRP[rp0,rnd,grey]      %s              #t2
MIRP[min,rnd,grey]      vstem_curve %s    #t3
SRP0                    %s              #s1
%s          #h_head(s1,s3,li,headtype="tho_thung")
""" % (t2,t3,s1,h_head(s1,s3,li,headtype="tho_thung"),)
    return hf_6(s0,s1, s2, add1,add2, g1=g1)


#----------------------------------------
def hf_8(s0, s1,add1, s2,i121, s3,add3, s3s, li, s4,add4, s5, g1="gap_186"):     #yo_yak
    return """
SRP0                    %s              #s0
MIRP[rp0,rnd,grey]      %s %s           #g1,s1   %s  #add1
MIRP[min,rnd,grey]      hstem %s        #s2
IP                      %s              #i121
SHPIX                   24 %s           #i121
MDRP[rnd,grey]          %s              #s3      %s  #add3
SHP[rp2]                %s              #s3s
%s          #f_ip(li)
%s          #exp_head_1(li[0])
MDRP[rp0,rnd,grey]      %s              #s4      %s  #add4
MIRP[min,rnd,grey]      hstem %s        #s5
SHPIX                   -24 %s          #s5
""" % (s0, g1,s1, add1, s2,i121, i121, s3,add3, s3s, li, h_exp_head_1(li[0],li[1]), s4,add4, s5,s5, )


def hf_yo_yak(s0, s1,s2,x2,s3, li3, s4,s5, s6,i6, g1="gap_127"):
    return """
SRP0                %s              #s0
MIRP[rp0,rnd,white] %s %s           #g1,s1
f_deltap    %s 9-8 %s 16+8 
MIRP[rp0,rnd,grey]  hstem %s        #s2
SRP0                %s              #s1
MIRP[rp0,rnd,grey]  hstem %s        #x2
f_deltap    %s 14-8 %s 15-8 %s 16-8 %s 17-8
%s      #h_head(x2,s3,li3,headtype="yo_yak")
f_deltap    %s 14+2 %s 15+2 %s 16+2
SRP0                %s              #s1
MDRP[rp0,rnd,grey]  %s              #s4
MIRP[rp0,rnd,grey]  hstem %s        #s5
MDRP[rnd,grey]      %s              #s6
IP                  %s              #i6
SHPIX               24 %s           #i6
""" % (s0,g1,s1,s1,s1, s2, s1,x2,x2,x2,x2,x2, h_head(x2,s3,li3,headtype="yo_yak"), li3[0],li3[0],li3[0], s1,s4,s5,s6,i6,i6, )

#....................
#def hf_yo_yak(s0, s1,s2, i121, s3,s3s, li, s4,s5):
#    add1 = """
#f_deltap                %s 9-8
#""" % tuple((s1,)*1)
#    add3 = ""
#    add4 = ""
#    return hf_8(s0, s1,add1, s2,i121, s3,add3, s3s, li, s4,add4, s5)
#

#----------------------------------------
def hf_9(s0,s1,s2,s3,s4,s5,add1="",add2="",add3="",add4="",add5="",g1="gap_kho_khwai"):
    add1 = """
f_deltap    %s 9-8  %s 10-8  %s 11-8         #s1
""" % tuple((s1,)*3) + add1
    add5 = """
f_deltap    %s 17+8  %s 23+8  %s 24+8
""" % (s5,s5,s5,) + add5
    return dhint.hf_kho_khwai(s0,s1,s2,s3,s4,s5,add1,add2,add3,add4,add5,g1)


#....................
def hf_kho_khwai(s0,s1,s2,s3,s4, s5,i15, s6, li6):
    add4 = """
f_deltap    %s 17-2 %s 18-2 %s 19-1
""" % tuple((s2,)*3)
    add3 = """
f_deltap    %s 15+8  %s 16+8
""" % tuple((s3,)*2)
    add5 = """
IP                  %s              #i15
%s      #h_head(s5,s6,li6,headtype="kho_khwai")
#ax#f_deltap    %s 17+3 %s 18+3 %s 19+3
#ax#f_deltap    %s 14+2 %s 15+3 %s 16+4
#ay#f_deltap    %s 14-8 %s 15-8 %s 16-8
""" % tuple((i15, h_head(s5,s6,li6,headtype="kho_khwai"),) + (li6[2]+1,)*3 + (i15+1,)*3 + (s2+2,)*3)
    return hf_9(s0,s1,s2,s3,s4,s5,add3=add3,add4=add4,add5=add5)


def hf_do_dek(s0,s1,s2,s3,s4,i34, s5,s6, li6):
    add4 = """
IP                  %s              #i34
""" % (i34,)
    add5 = """
%s          #h_head(s5,s6,li6,headtype="do_dek")
f_deltap    %s 13+1 %s 14+1 %s 15+1 %s 16+1
#ay#f_deltap    %s 13-8 %s 14-8 %s 15-8 %s 16-8  #s2+2
""" % tuple((h_head(s5,s6,li6,headtype="do_dek"),) + (li6[2],)*4 + (s2+2,)*4)
    return hf_9(s0,s1,s2,s3,s4,s5,add4=add4,add5=add5)



#------------------------------------------------
#dhint.hr_1
#------------------------------------------------
def hr1(s0,s1,s2,add1="",add2="",g1="gap_r_ko"):
    return dhint.hr_1(s0,s1,s2,add1,add2,g1)


def hr1s(s0,s1,s2,s2s,add1="",add2="",g1="gap_r_ko"):
    return dhint.hr_1s(s0,s1,s2,s2s,add1,add2,g1)

    
#....................
def hr_ko_kai(s0,s1,s2,g1="gap_r_ko"):
    return hr1(s0,s1,s2,g1=g1)

def hr_kho_khwai(s0,s1,s2,g1="gap_r_ko"):
    add1 = """
f_deltap    %s 32+8
""" % (s1,)
    return hr1(s0,s1,s2,add1,g1=g1)

def hr_tho_thong(s0,s1,t1,s2,g1="gap_164"):
    add1 = """
MDRP[rnd,grey]          %s          #t1
""" % (t1,)
    return hr1(s0,s1,s2,add1,g1=g1)

def hr_so_sala(s0,s1,s2,g1="gap_186"):
    add1 = """
f_deltap    %s 17+8 %s 18+8 %s 19+8 %s 28+8 %s 30+8 
""" % tuple((s1,)*5)
    return hr1(s0,s1,s2,add1,g1=g1)

def hr_ho_nokhuk(s0, s1, s2, li, g1="gap_186"):
    add1 = """
f_deltap        %s 17+8  %s 18+8 %s 28+8 %s 29+8 %s 30+8
""" % tuple((s1,)*5)
    add2 = f_ip(li)
    return hr1(s0,s1,s2,add1,add2,g1)

#..............................

#..............................
def hr1_kho_khai(s0,s1, s2, s3, s4, s5, s6,add1="",add2="",add3="",add4="",add5="",add6="",g1="gap_r_ko"):
    add2 = add2 + """
MDRP[rp0,rnd,grey]      %s              #s3     %s  #add3
MIRP[min,rnd,grey]      hstem %s        #s4     %s  #add4
SRP0                    %s              #s2
MDRP[rp0,min,rnd,grey]  %s              #s5     %s  #add5
MDRP[grey]              %s              #s6
f_deltap        %s 15+1 %s 16+1 %s 17-2 %s 18-2 %s 19-2 %s 20-1
SHPIX                   16 %s           #s6     %s  #add6
""" % tuple((s3,add3, s4,add4, s2, s5,add5,)+(s6,)*8 + (add6,))
    return hr1(s0,s1, s2,add1,add2,g1)


#....................
def hr_tho_nangmontho(s0, s1,s2, s3,s3s, s4, s5, i5, s6, t51):
    add1 = """
#f_deltap    %s 20+8  %s 21+8  %s 22+8  
""" % tuple((s1,)*3)
    add2 = add4 = add6 = ""
    add3 = """
ALIGNRP                 %s              #s3s
""" % (s3s,)
    add5 = """
IP                      %s              #i5
""" % (i5,)
    add6 = """
SRP0                    %s              #i5
MDRP[grey]              %s              #t51
""" % (i5,t51,)
    return hr1_kho_khai(s0,s1, s2, s3, s4, s5, s6,add1,add2,add3,add4,add5,add6)


#....................

def hr_kho_khai_1(s0,s1, s2, s3,s4,s5,s6, add1="",add2="",g1="gap_164"):
    add3 = add4 = add6 = ""
    add5 = """
f_deltap        %s 16-1 %s 23+8 %s 26+8 %s 27+8
""" % tuple((s5,)*4)
    return hr1_kho_khai(s0,s1, s2, s3, s4, s5, s6,add1,add2,add3,add4,add5,add6,g1)


def hr_kho_khai(s0,s1, s2, s3,s4,s5,s6, add1="",add2="",g1="gap_164"):
    add1 = """
f_deltap        %s 22+8 %s 36+8
""" % tuple((s1,)*2) + add1
    return hr_kho_khai_1(s0,s1, s2, s3,s4,s5,s6, add1,add2,g1)


def hr_cho_chang(s0,s1, s2, t21,t22, s3,s4,s5,s6, s7,s8, g1="gap_186"):
    add1 = """
f_deltap        %s 13-8 %s 17+8 %s 18+8 %s 19+8 %s 21+8 %s 28+8 %s 30+8 %s 37+8 %s 40+8
""" % tuple((s1,)*9)
    add2 = """
MDRP[rp0,rnd,grey]  %s          #t21
MIRP[min,rnd,grey]  hstem %s    #t22
SRP0                %s          #s1
""" % (t21,t22,s1,)
    return hr_kho_khai_1(s0,s1, s2, s3,s4,s5,s6, add1,add2,g1) + """
MDRP[rp0,grey]      %s          #s7
MDRP[grey]          %s          #s8
SHPIX               -24 %s      #s8
""" % (s7,s8,s8,)


#..............................
def hr_kho_khuat_1(s0,s1, s2, s3,s4,s5,s6, add1="",add2="",g1="gap_164"):
    add3 = add4 = add6 = ""
    add5 = """
#f_deltap    %s 23-8
""" % tuple((s5,)*1)
    return hr1_kho_khai(s0,s1, s2, s3, s4, s5, s6,add1,add2,add3,add4,add5,add6,g1)


def hr_kho_khuat(s0, s1,s2, s3,s4, s5,s6):
    add2 = add3 = add4 = add6 = ""
    add1 = """
f_deltap        %s 26+8 %s 28+8
""" % tuple((s1,)*2)
    return hr_kho_khuat_1(s0,s1, s2, s3,s4,s5,s6, add1,add2)


def hr_so_so(s0,s1, s2, t21,t22, s3,s4,s5,s6, s7,s8, g1="gap_186"):
    add1 = """
f_deltap        %s 17+8 %s 18+8 %s 19+8 %s 21+8 %s 26+8 %s 28+8 %s 29+8 %s 30+8 %s 31+8 %s 36-8 %s 39+8 %s 40+8
""" % tuple((s1,)*12)
    add2 = """
MDRP[rp0,rnd,grey]  %s          #t21
MIRP[min,rnd,grey]  hstem %s    #t22
SRP0                %s          #s1
""" % (t21,t22,s1,)
    return hr_kho_khuat_1(s0,s1, s2, s3,s4,s5,s6, add1,add2,g1) + """
MDRP[rp0,grey]      %s          #s7
MDRP[grey]          %s          #s8
SHPIX               -24 %s      #s8
""" % (s7,s8,s8,)


#..............................
def hr_kho_rakhang(s0, s1,s2,s2s, s3,s3s, s4, t41, li, s5,s6):
    add1 = ""
    add2 = """
SHP[rp2]                %s                  #s2s
""" % (s3s,)
    add3 = """
f_deltap                %s 9+8  %s 17+8  
""" % tuple((s3,)*2)
    add4 = """
ALIGNRP                 %s                  #s3s
%s          #h_head(s4,t41,li,headtype="ngo_ngu)
""" % (s3s, h_head(s4,t41,li,headtype="ngo_ngu"),)
    add5 = """
f_deltap                %s 17+8
""" % tuple((s5,)*1)
    add6 = ""
    return hr1_kho_khai(s0,s1, s2, s3, s4, s5, s6,add1,add2,add3,add4,add5,add6)


#----------------------------------------
def hr_6(s0,s1,s2, s3, li, add3="", g1="gap_164"):
    add1 = ""
    add2 = h_head(s1,s3,li,headtype="ngo_ngu") + add3
    return hr1(s0,s1,s2,add1, add2, g1)

#....................
def hr_ngo_ngu(s0,s1,s2, s3, li, s4,s5):
    add3 = """
MDRP[rp0,rnd,grey]      %s                  #s4
MDRP[grey]              %s                  #s5
f_deltap                %s 14-2  %s 15-3  %s 16-5
""" % (s4,s5,s5,s5,s5,)
    return hr_6(s0,s1,s2, s3, li, add3)


def hr_wo_waen(s0,s1,s2, s3, li):
    return hr_6(s0,s1,s2, s3, li)


def hr_ro_rua(s0,s1,s2,s3, li, t1):
    add3 = """
MDRP[rnd,grey]          %s                  #t1
""" % (t1,)
    return hr_6(s0,s1,s2, s3, li, add3, g1="gap_240")


#----------------------------------------
def hr_7(s0,s1,s2,s3,s4,add1="",add2="",add3="",add4="",g1="gap_r_ko"):
    add2 = add2 + """
MDRP[rp0,rnd,grey]      %s              #s3     %s  #add3
MIRP[min,rnd,grey]      hstem %s        #s4     %s  #add4
""" % (s3,add3, s4,add4,)
    return hr1(s0,s1,s2,add1,add2,g1)

#....................
def hr_yo_ying(s0,s1,s2,s3,s4,add1="",add2="",add3="",add4="",g1="gap_r_ko"):
    add3 = add3 + """
f_deltap        %s  11+8
""" % (s3,)
    return hr_7(s0,s1,s2,s3,s4,add1,add2,add3,add4,g1)

def hr_cho_choe(s0,s1,s2,s2s,s3,s4,s5,s6,li6,add1="",add2="",add3="",add4="",add5="",add6="",g1="gap_r_ko"):
    add2 = """
SHP[rp2]                %s          #s2s
""" % (s2s,)
    add3 = """
f_deltap        %s 11+8
""" % (s3,)
    add4 = """
MDRP[rp0,rnd,grey]      %s          #s5     %s  #add5
f_deltap    %s 14+8  %s 19-8  %s 25+8 
%s          #h_head(s5,s6,li6,headtype="cho_choe")  %s  #add6
""" % (s5,add5, s5,s5,s5, h_head(s5,s6,li6,headtype="cho_choe"),add6,)
    return hr_7(s0,s1,s2,s3,s4,add1,add2,add3,add4,g1)


def hr_tho_phuthao(s0,s1,s2,s2s,s3,s4,s5,s6,li6,add1="",add2="",add3="",add4="",add5="",add6="",g1="gap_r_ko"):
    add2 = """
SHP[rp2]                %s          #s2s
""" % (s2s,)
    add3 = """
f_deltap        %s 12+8
""" % (s3,)
    add4 = """
MDRP[rp0,rnd,grey]      %s          #s5     %s  #add5
f_deltap    %s 14+8  %s 19-8  %s 25+8 %s 26+8
%s          #h_head(s5,s6,li6,headtype="cho_choe")  %s  #add6
""" % (s5,add5, s5,s5,s5,s5, h_head(s5,s6,li6,headtype="cho_choe"),add6,)
    return hr_7(s0,s1,s2,s3,s4,add1,add2,add3,add4,g1)

#----------------------------------------
def hr_mo_ma(s0,s1,s2,s2s):
    return hr1s(s0,s1,s2,s2s)


def hr_lo_chula(s0,s1,s2,s2s, t3, s3, li, g1="gap_205"):
    add1 = ""
    add2 = """
MDRP[min,rnd,grey]          %s              #t3
MDRP[rnd,grey]              %s              #s3
%s          #f_ip(li)
%s          #exp_head_2(li[1])
""" % (t3,s3,f_ip(li),exp_head_2(li[1]))
    return hr1s(s0,s1,s2,s2s,add1, add2, g1)


def hr_do_chada(s0,s1,s2,s2s, s3, s4, li):
    add1 = ""
    add2 = """
MDRP[rp0,rnd,grey]          %s              #s3
MDRP[min,rnd,grey]          %s              #s4
%s          #add_ip(s4,s2,li)
""" % (s3, s4, add_ip(s4,s2,li),)
    return hr1s(s0,s1,s2,s2s,add1, add2)


def hr_bo_baimai(s0,s1,s2):
    return hr1(s0,s1,s2)

def hr_so_rusi(s0,s1,s1s,t1, s2,s2s,g1="gap_164"):
    add1 = """
ALIGNRP             %s                  #s1s
MDRP[min,rnd,grey]  %s                  #t1
""" % (s1s,t1,)
    add2 = """
SHP[rp2]            %s                  #s2s
""" % (s2s,)
    return hr1(s0,s1,s2,add1, add2, g1)


def hr_yo_yak(s0,s1,s2):
    add1 = """
#f_deltap    %s 19+8  %s 20+8  
""" % (s1,s1, )
    add2 = ""
    return hr1(s0,s1,s2,add1, add2)


def hr_tho_thahan(s0,s1,s2,add1="",add2=""):
    return hr1(s0,s1,s2, add1, add2)


def hr_ho_hip(s0,s1,s2, s3,s4, li,add1=""):
    add2 = """
MDRP[rp0,rnd,grey]      %s              #s3
MDRP[rnd,grey]          %s              #s4
%s          #h_reduce_head(s4,headtype="ho_hip",s3)
%s          #f_ip(li)
SHPIX                   16 %s           #li[2]
SHPIX                   -16 %s          #li[3]
""" % (s3,s4, h_reduce_head(s4,headtype="ho_hip",s1=s3), f_ip(li),li[2],li[3])
    return hr_tho_thahan(s0,s1,s2,add1, add2)


#------------------------------------------------
def hr_2(s0,s1,add1,s2,add2, li, s3,add3, s4, g1="gap_84"):    #no_nu
    return """
SRP0                %s              #s0
MIRP[rp0,rnd,white] %s %s           #g1,s1  %s  #add1
MDRP[rnd,grey]      %s              #s2     %s  #add2
%s          #f_ip(li)
%s          #exp_head_1(li[0])
MDRP[rp0,rnd,grey]  %s              #s3     %s  #add3
MIRP[min,rnd,grey]  hstem %s        #s4
""" % (s0,g1,s1,add1, s2,add2, f_ip(li), h_exp_head_1(li[0],li[1]), s3,add3, s4)


#....................
def hr_no_nu(s0,s1,s2, li, s3,s4,g1="gap_84"):
    return """
SRP0                    %s          #s0
MIRP[rp0,rnd,grey]      %s %s       #g1,s1
f_deltap    %s 9+8  %s 10+8  %s 11+8  %s 12+8  #s1
%s          #h_head(s1,s2,li,headtype="no_nu")
MDRP[rp0,min,rnd,grey]  %s          #s3
MIRP[min,rnd,grey]      hstem %s    #s4
""" % tuple((s0,g1) + (s1,)*5 + (h_head(s1,s2,li,headtype="no_nu"),s3,s4))

    return hr1(s0,s3,s4,g1=g1)


#----------------------------------------
def hr_3(s0,s1, s2,s3,s4,i341,add1="",add3="",g1="gap_113"):    #cho_chan
    return """
SRP0                %s              #s0  
MIRP[rp0,rnd,grey]  %s %s           #g1,s1  %s  #add1
MIRP[min,rnd,grey]  hstem %s        #s2  
MDRP[rp0,rnd,grey]  %s              #s3     %s  #add3 
MIRP[min,rnd,grey]  hstem %s        #s4  
IP                  %s              #i341
""" % (s0, g1,s1,add1, s2,s3,add3,s4, i341)

#....................
def hr_cho_chan(s0,s1,s2,s3,s4,i341,g1="gap_113"):
    add1 = ""
    add3 = """
f_deltap    %s 13+8
""" % (s3,)
    return hr_3(s0,s1, s2,s3,s4,i341, add1,add3,g1)


def hr_tho_than(s0,s1,t1,s2,s3,s4,i341,g1="gap_164"):
    add1 = """
MDRP[rnd,grey]          %s              #t1
""" % (t1,)
    add3=""
    return hr_3(s0,s1, s2,s3,s4,i341,add1,add3,g1)


#----------------------------------------
def hr_4(s1,s2, li, add2=""):     #sara i
    return """
MDAP[rnd]               %s              #s1
MDRP[rnd,grey]          %s              #s2
%s          #f_ip(li)       %s  #add2
#ax#SHPIX   -24 %s          #li[0]-2
#ax#SHPIX   24 %s           #li[1]+2
""" % (s1,s2, f_ip(li), add2, li[0]-2,li[1]+2) + \
    f_dstr_dict({
        li[0]-2:"14-4 15-4 16-4",
        li[1]+2:"14+3 15+3 16+3"}, aip="#ax#")


#....................
def hr_sara_i(s1,s2, li):
    return hr_4(s1,s2, li)


def hr_sara_ii(s1,s2, li, s3):
    add2 = """
MDRP[min,rnd,grey]      %s              #s3
SHPIX                   -8 %s           #s1
SHPIX                   8 %s            #s3
""" % (s3,s1,s3,)
    return hr_4(s1,s2, li, add2)


def hr_sara_ue(s1,s2, li2, s3,s4, li4):
    add2 = """
MDRP[rp0,min,rnd,grey]  %s              #s3
MDRP[rnd,grey]          %s              #s4
f_deltap    %s 12-8  %s 13-8  %s 14-8  %s 15-8 %s 16-8 
%s          #f_ip(li4)
""" % (s3,s4, s4,s4,s4,s4,s4, f_ip(li4),)
    return hr_4(s1,s2, li2, add2)


def hr_sara_uee(s1,s2, li, s3,s4,s5):
    add2 = """
MDRP[rp0,min,rnd,grey]  %s              #s3
MDRP[rp0,min,rnd,grey]  %s              #s4
MDRP[min,rnd,grey]      %s              #s5
SHPIX                   -8 %s           #s1
SHPIX                   8 %s            #s3
SHPIX                   -8 %s           #s4
SHPIX                   8 %s            #s5
""" % (s3,s4,s5,s1,s3,s4,s5,)
    return hr_4(s1,s2, li, add2)


#------------------------------------------------
def hr_5(s0,s1,s2, li, s3, add3="",g1="gap_84"): #sara e
    return """
SRP0                    %s          #s0
MIRP[rp0,rnd,white]     %s %s       #g1,s1
f_deltap    %s 9+8 %s 12+8 %s 13+8
%s          #h_head(s1,s2,li,move_rp0=True,headtype="sara_e")
MIRP[min,rnd,grey]      hstem %s    #s3     %s  #add3
""" % tuple((s0,g1,) + (s1,)*4 + (h_head(s1,s2,li,move_rp0=True,headtype="sara_e"),s3,add3,))


#....................
def hr_sara_e(s0,s1,s2, li, s3): #sara e
    return hr_5(s0,s1,s2, li, s3)


#....................
def hr_sara_u(s1,s2,s3, li):
    return """
MDAP[rnd]                %s              #s1
MDRP[min,rnd,grey]       %s              #s2
%s      #h_head(s1,s3,li,headtype="sara_u")
SHPIX                    -8 %s           #s1
SHPIX                     8 %s           #s2
""" % (s1,s2, h_head(s1,s3,li,headtype="sara_u"), s1,s2,)


def hr_sara_uu(s1,s2,s3,s4,s5, li):
    return """
MDAP[rnd]                %s              #s1
MDRP[rp0,min,rnd,grey]   %s              #s2
MDRP[rp0,min,rnd,grey]   %s              #s3
MDRP[min,rnd,grey]       %s              #s4
%s      #h_head(s3,s5,li,headtype="sara_u")
SHPIX                    -8 %s           #s1
SHPIX                    8 %s           #s2
SHPIX                    -8 %s           #s3
SHPIX                    12 %s           #s4
""" % (s1,s2,s3, s4, h_head(s3,s5,li,headtype="sara_u"), s1,s2,s3,s4,)


#------------------------------------------------
def v0(s0):
    return  """
MDAP[rnd]               %s              #s0
""" % (s0,)


def v0s(s0,s0s):
    return """
MDAP[rnd]               %s              #s0
ALIGNRP                 %s              #s0s
""" % (s0, s0s,)


#------------------------------------------------
def vsb0(s0,s0s, s1,thin=False):
    if thin:
        add1 = """
f_deltap    %s 14-1 %s 15-2 %s 16-2
""" % tuple((s1,)*3)
    else:
        add1 = ""
    return """
MDAP[rnd]               %s              #s0
ALIGNRP                 %s              #s0s
%s          #vstem_b1(s1)   %s  #add1
""" % (s0,s0s, vstem_b1(s1),add1, )

def vsb0s(s0,s0s, s1,s1s,thin=False):
    return vsb0(s0,s0s, s1,thin) + """
SHP[rp2]                %s              #s1s
""" % (s1s,)


#------------------------------------------------

def vb_0(s0,add0, s1,add1, stem='vstem_line', thin=False):
    if thin:
        add1 = add1 + """
f_deltap    %s 14-1 %s 15-2 %s 16-3
""" % tuple((s1,)*3)
    return """
MDAP[rnd]               %s              #s0     %s #add0
%s          #vstem_b1(s1)   %s  #add1
""" % (s0,add0, vstem_b1(s1),add1)

def vb0(s0,s1,thin=False):
    add0 = add1 = ""
    return vb_0(s0,add0, s1,add1,thin=thin)

def vb0s(s0,s1,s1s,thin=False):
    add0 = ""
    add1 = """
SHP[rp2]                %s              #s1s
""" % (s1s,)
    return vb_0(s0,add0, s1,add1,thin=thin)

#....................
def vb1(s0,s1):
    add0 = ""
    add1 = ""
    return vb_0(s0,add0, s1,add1, stem='vstem_line')

def vb1s(s0,s1,s1s):
    add0 = ""
    add1 = """
SHP[rp2]                %s              #s1s
""" % (s1s,)
    return vb_0(s0,add0, s1,add1, stem='vstem_line')

def vbs1s(s0,s0s, s1,s1s):
    add0 = """
ALIGNRP                 %s              #s0s
""" % (s0s,)
    add1 = """
SHP[rp2]                %s              #s1s
""" % (s1s,)
    return vb_0(s0,add0, s1,add1, stem='vstem_line')


#------------------------------------------------
def vb0lc(s0,s1,s2,add1=""):
    return """
SRP0                %s              #s0
MIRP[rp0,rnd,grey]  vheight_lo %s   #s1     %s #add1
%s      #vstem_c_bottom(s2)
""" % (s0,s1,add1,vstem_c_bottom(s2))


def vb0lcs(s0,s1,s2,s2s,add1=""):
    return vb0lc(s0,s1,s2,add1) + """
SHP[rp2]            %s              #s2s
""" % (s2s,)


def vb0lscs(s0,s1,s1s,s2,s2s):
    add1 = """
ALIGNRP             %s              #s1s
""" % (s1s,)
    return vb0lcs(s0,s1,s2,s2s,add1)


#....................
def vb0_low_head(s0,s1,add1,s2,add2):
    return """
SRP0                    %s              #s0
MIRP[rp0,rnd,grey]      vheight_lo %s   #s1         %s  #add1
MDRP[rnd,grey]          %s              #s2         %s  #add2
""" % (s0,s1,add1, s2, add2)


def vb0l_head(s0,s1,s2, li,headtype="bottom_up"):
    add1 = ""
    add2 = """
%s          #v_head(s1,s2,li,headtype=headtype)
""" % (v_head(s1,s2,li,headtype=headtype),)
    return vb0_low_head(s0,s1,add1,s2,add2)


def vb0l_mo_ma(s0,s1,s2, li):
    add1 = ""
    add2 = """
%s          #f_ip(li)
%s          #v_exp_head(li[0],li[1])
""" % (f_ip(li),v_exp_head(li[0],li[1]),)
    return vb0_low_head(s0,s1,add1,s2,add2)


def vb0l_cho_choe(s0,s1,s1s, s2,s2s, li2):
    add1 = """
ALIGNRP                 %s              #s1s
""" % (s1s)
    add2 = """
%s          #v_head(s1,s2,li2,headtype="bottom_up")
SHP[rp2]                %s              #s2s
%s          #v_exp_head(li2[2],li2[3])
""" % (v_head(s1,s2,li2,headtype="bottom_up"), s2s, v_exp_head(li2[2],li2[3]),)
    return vb0_low_head(s0,s1,add1,s2,add2)


#------------------------------------------------
def vl0_1(s0,s1,add1):    #do_chada
    return """
SRP0                    %s              #s0
MIRP[rp0,rnd,grey]      vheight_lu %s   #s1     %s  #add1      
""" % (s0,s1,add1,)

#....................
def vl_do_chada(s0,s1, s1s, s2, s3, li):
    add1 = """
ALIGNRP                 %s              #s1s
%s         #vstem_c1(s2)
MDRP[rnd,grey]          %s              #s3
%s         #f_ip(li)
""" % (s1s, vstem_c1(s2), s3, f_ip(li),)
    return vl0_1(s0,s1,add1)


def vl_to_patak(s0,s1, s1s1,s1s2, s2,s2s, s3, li):
    add1 = """
ALIGNRP                 %s              #s1s1
ALIGNRP                 %s              #s1s2
%s          #vstem_c1(s2)
SHP[rp2]                %s              #s2s
MDRP[rnd,grey]          %s              #s3
%s          #f_ip(li)
""" % (s1s1,s1s2, vstem_c1(s2), s2s, s3, f_ip(li),)
    return vl0_1(s0,s1,add1)


#..............................
def vl0_2(s0,s1,add1):    #ru-lu
    return """
SRP0                    %s              #s0
MIRP[rnd,grey]          vheight_lu %s   #s1     %s  #add1      
""" % (s0,s1,add1,)

#....................
def vl0_ru(s0,s1):
    add1 = ""
    return vl0_2(s0,s1,add1)


#------------------------------------------------
def vf1(s1, li1, s2, li2, add1="", add2="", move_rp02=False):
    return vtc1(s1,li1,add1) + """
%s      #v_head(s1,s2,li2,headtype="top_down")  %s  #add2
""" % (v_head(s1,s2,li2,headtype="top_down") ,add2)


#....................
def vf_no_nu(s1,s2, li):
    add1 = ""
    return vf1(s1,[],s2,li)


def vfr_lo_chula(s1, s2, li2, s3,s4, li3):
    add1 = ""
    add2 = """
MDRP[rp0,min,rnd,grey]  %s                  #s3
MDRP[rnd,grey]          %s                  #s4
%s          #f_ip(li3)
""" % (s3,s4, f_ip(li3),)
    return vf1(s1,[], s2, li2, add1,add2)


def vfr_tho_thahan(s1,s1s, li1, t2, s2, li2):
    add1 = """
ALIGNRP                 %s              #s1s
""" % (s1s,) + vstem_c1(t2)
    if li1:
        temp = """
f_deltap    %s 14-6 %s 15-6 %s 16-6
""" % tuple((li1[0],)*3)
    else:
        temp = ""
    return vf1(s1,li1, s2, li2,add1) + temp


def vfr_ho_hip(s1,s1s, li1, s2, li2, t2):
    add1 = """
ALIGNRP                 %s              #s1s
""" % (s1s,)
    add2 = """
MDRP[grey]              %s              #t2
SHPIX                   8 %s
""" % (t2,t2,)
    return vf1(s1,li1,s2, li2, add1, add2, move_rp02=True) + """
f_deltap    %s 14-4 %s 15-4 %s 16-4
""" % tuple((li1[0],)*3)


#------------------------------------------------
def vm_1n(s1,add1):
    return """
MIRP[rp0,rnd,grey]  vheight_num %s      #s1         %s  #add1
""" % (s1, add1)


def vtc1n(s1):
    add1 = ""
    return vm_1n(s1,add1)

def vtc1ns(s1,s1s):
    add1 = """
ALIGNRP                 %s              #s1s
""" % (s1s,)
    return vm_1n(s1,add1)


#------------------------------------------------
#------------------------------------------------
#dhint.vtc_1    : v-top curve
#....................
def vtc1(s1,li=[],add1=""):
    return dhint.vtc_1(s1,li,add1)


def vtc1s(s1,s1s,li=[],add1=""):
    add1 = """
ALIGNRP             %s                  #s1s
""" % (s1s,) + add1
    return vtc1(s1,li,add1,)


#....................
def vtc1_ko_kai(s1, li):
    return vtc1(s1, li) + """
#ay#%s      #notch_1(li[2])
""" % (notch_1(li[2]),)


def vtc1s_kho_khon(s1,s1s, li):
    return vtc1s(s1,s1s,li)


def vtc1s_to_tao(s1,s1s):
    return vtc1s(s1,s1s)


#------------------------------------------------
def vm3(s1, i1):
    return """
MDRP[rp0,min,rnd,grey]  %s                  #s1
IP                      %s                  #i1
%s      #groove_1(i1)
""" % (s1,i1,groove_1(i1),)


#------------------------------------------------
def vmh0(s1, s2, li2,add1="",add2="",move_rp02=False):
    return """
MDRP[rp0,min,rnd,white] %s              #s1     %s  #add1
%s      #v_head(s1,s2,li2,headtype="middle_down")   %s  #add2
""" % (s1,add1, v_head(s1,s2,li2,headtype="middle_down"), add2,)


#..............................
def vmh_kho_khwai(s1,s2, li2,add1=""):
    add1 = """
f_deltap                %s 9-8
""" % (s1,)
    return vmh0(s1, s2,li2,add1,add2="")


def vmh_kho_khon(s1,s2, li2):
    return vmh0(s1, s2,li2,add1="",add2="")


def vmh_do_dek(s1,s2, li2, add1=""):
    add1 = """
f_deltap                %s 9-8
""" % (s1,)
    add2 = """
SHPIX                   -12 %s          #li2[1]
""" % (li2[1],)
    return vmh0(s1, s2,li2,add1,add2)


def vmh_cho_chan(s1,s2, li2):
    add1 = ""
    return vmh0(s1,s2,li2,add1)


def vmh_tho_than(s1, li1, s2, li2, s3):
    add1 = """
f_deltap                %s 9-8 %s 10-8
%s      #f_ip(li1)
""" % (s1,s1, f_ip(li1),)
    return vmh0(s1,s2,li2,add1) + """
SRP0                    %s              #li1[3]
MDRP[grey]              %s              #s3
SHPIX                   16 %s           #li1[3]
""" % (li1[3],s3,li1[3],)


def vmh_o_ang(s1,s2, li2):
    add1 = """
f_deltap                %s 9-8
""" % (s1,)
    return vmh0(s1, s2,li2,add1)


def vmh_ho_nokhuk(s1,s2, li2):
    add1 = """
f_deltap                %s 12-8  
""" % (s1,)
    return vmh0(s1,s2,li2,add1)


#------------------------------------------------
def vm_4(s1,s2,li,add4="",add5=""):
    return """
MDAP[rnd]               %s              #s1
MDRP[rp0,min,rnd,grey]  %s              #s2
f_deltap    %s 15+8
%s          #f_ip(li)               %s  #add2
SHPIX                   -8 %s           #li[1]
SHPIX                    8 %s           #li[0]
""" % (s1,s2, s2, f_ip(li),add4,li[1],li[0],) + \
    f_dstr_dict({\
        s1:"14+2 15+2 16+2",
        li[0]:"9-3 10-3 11-3 12-3 13-3 14-3" })


#....................
def vm_sara_i(s1,s2,li):
    return vm_4(s1,s2,li)


def vm_sara_ii(s1,s2, li, s3):
    add2 = """
MDRP[min,rnd,grey]      %s              #s3
SHPIX                   -24 %s          #li[2]
""" % (s3,li[2])
    return vm_4(s1,s2,li,add2)


def vm_sara_ue(s1,s2,li2, s3,s4,li4):
    add2 = """
MDRP[rp0,rnd,grey]  %s              #s3
MDRP[rnd,grey]          %s              #s4
f_deltap    %s 10-8 %s 12-8  %s 13-8  %s 14-8  %s 15-8 %s 16-8 %s 17-8
%s          #f_ip(li4)
""" % (s3,s4, s4,s4,s4,s4,s4,s4,s4, f_ip(li4),)
    return vm_4(s1,s2,li2,add2)


def vm_sara_uee(s1,s2, li, s3,s3s):
    add2 = """
MDRP[min,rnd,grey]      %s              #s3
SHP[rp2]                %s              #s3s
""" % (s3,s3s,)
    return vm_4(s1,s2,li,add2)



#------------------------------------------------
def vr1(s1,move_rp0=False):
    if move_rp0:
        return """
MIRP[rp0,rnd,grey]      vheight %s
""" % (s1,)
    else:
        return """
MIRP[rnd,grey]          vheight %s
""" % (s1,)

def vr1_po(s1):
    return """
MIRP[rnd,grey]          vheight_po %s
""" % (s1,)

#------------------------------------------------
def vr2(s1):
    return """
MIRP[grey]              vstem_curve   %s
SHPIX                   24          %s
""" % (s1,s1)

#------------------------------------------------

def vf_kho_khai_1(s1, s2, s3,s4, li4, add1="",add3="",headtype="kho_khai"):
    return """
MIRP[rp0,rnd,grey]      vheight_shoot %s    #s1     %s  #add1
MDRP[rp0,rnd,grey]      %s                  #s3     %s  #add3
%s          #v_head(s3,s4,headtype)
""" % (s1,add1, s3,add3, v_head(s3,s4,li4,headtype),)


#....................
def vf_kho_khai(s1, s2, s3,s4, li4, add1=""):
    add1 = add1 + f_stem(s1,s2,stem="v_kho_khai",type="-",thin=True)
    add3 = f_dstr(s3,"10+8 11+8 14+8 15+8 16+8 26+8 28+8 31+8 ")
    return vf_kho_khai_1(s1, s2,s3,s4, li4, add1,add3)


def vfr_cho_chang(s1,li1,t1, s2,s3,s4,li4):
    add1 = """
%s          #f_ip(li1)
MDRP[min,rnd,grey]      %s          #t1   
""" % (f_ip(li1),t1,)
    return vf_kho_khai(s1, s2,s3,s4, li4, add1)

def vf_kho_khuat(s1,s1s,s2,s2s,p2,i2,s3,s4,li4,add1=""):
    add1 = add1 + """
ALIGNRP                 %s          #s1s
MDRP[min,rnd,grey]      %s          #s2
SHPIX                   12 %s       #s2
SHP[rp2]                %s          #s2s
f_deltap    %s 26+4 %s 27+4
MDRP[rnd,grey]          %s          #p2
IP                      %s          #i2
SHPIX                   -12 %s      #p2
SHPIX                   -12 %s      #i2
f_deltap    %s 26+8 %s 27+8 %s 26+4 %s 27+4
MDRP[rp0,rnd,grey]      %s          #s3
f_deltap    %s 17+8 %s 25-8 %s 38-8
""" % (s1s,s2,s2,s2s, s2s,s2s, p2,i2,p2,i2, p2,p2,i2,i2, s3, s3,s3,s3,)
    add3 = ""
    return vf_kho_khai_1(s1, s2,s3,s4, li4, add1,add3,headtype="kho_khuat")

def vfr_so_so(s1,s1s, li1, t1, s2,s2s, p2,i2, s3,s4,li4):
    add1 = """
%s      #f_ip(li1)
MDRP[min,rnd,grey]      %s          #t1
""" % (f_ip(li1),t1,)
    return vf_kho_khuat(s1,s1s,s2,s2s,p2,i2,s3,s4,li4,add1)

def vfr_tho_nangmontho(s1,s1s,s1ss, t1, s2,s2s, p2,i2, s3,s4,li4):
    add1 = """
ALIGNRP                 %s          #s1ss
%s      #vstem_c1(t1)
""" % (s1ss, vstem_c1(t1),)
    return vf_kho_khuat(s1,s1s,s2,s2s,p2,i2,s3,s4,li4,add1)


#------------------------------------------------
def hadd_cho_chan(s1,s2, i121, s3):
    return """
SRP1                %s              #s1=    11
SRP2                %s              #s2=    13
IP                  %s              #i121=  12
SRP0                %s                      #i121
MDRP[grey]          %s              #s3=    2
#ax#SHPIX           12 %s           #s3
#ay#SHPIX           24 %s           #s3
""" % (s1,s2,i121, i121, s3,s3,s3,)


#------------------------------------------------
def hadd_no_nen(s1,s1s,s2):
    return """
MDRP[rp0,rnd,grey]      %s              #s1
f_deltap        %s 15+8  %s 20+8
ALIGNRP                 %s              #s1s
MIRP[min,rnd,grey]      hstem %s        #s2
""" % (s1,s1,s1,s1s,s2,)


#------------------------------------------------
def hadd_tho_thahan(s1,s2,s3,s4):
    return """
SRP1                    %s              #s1
SRP2                    %s              #s2
IP                      %s              #s3
SRP0                    %s              #s3
MDRP[grey]              %s              #s4
#SHPIX                   -12 %s          #s4
""" % (s1,s2,s3,s3,s4,s4)


#------------------------------------------------
def hadd_pho_phan(s1,s2, li, s3,s4):
    return """
%s      #add_ip(s1,s2,li)
SRP0                    %s              #li[1]
MDRP[grey]              %s              #s3
MDRP[grey]              %s              #s4
SHPIX                   8 %s            #s3
SHPIX                   -8 %s           #s4
""" % (add_ip(s1,s2,li), li[1],s3,s4,s3,s4,)


#------------------------------------------------
def vmh_tho_thong(s1, li, s2):
    return """
MDRP[rnd,grey]          %s              #s1
%s      #f_ip(li)
SRP0                    %s              #li[3]
MDRP[grey]              %s              #s2
SHPIX                   16 %s           #s2
f_deltap    %s 15-1 %s 16-1
""" % (s1, f_ip(li), li[3],s2,s2, li[2],li[2],)


#------------------------------------------------
def vadd_yo_yak(s1,s2, i12,s3, i123):
    return """
SRP1                    %s              #s1
SRP2                    %s              #s2
IP                      %s              #i12
MDAP[rnd]               %s              #i12
%s      #vstem_b1(s3)
IP                      %s              #i123
""" % (s1,s2, i12,i12, vstem_b1(s3), i123,)


#------------------------------------------------
def vadd_lo_ling(s1,s2):
    return """
MDAP[rnd]               %s              #s1
f_deltap    %s 9-8 %s 10-8 %s 17-8 %s 19-8 
%s      #vstem_b2(s2,thin=True)
""" % tuple((s1,)*5 + (vstem_b2(s2,thin=True),))


#------------------------------------------------
def vadd_so_rusi(s1,s2, li):
    return """
MDAP[rnd]               %s              #s1
MDRP[rnd,grey]          %s              #s2
%s          #f_ip(li)
""" % (s1,s2, f_ip(li),)


def vadd_paiyan_noi(t1, s2, li2, s3):
    return """
%s      #vstem_c1(t1,thin=True)
MDRP[rp0,rnd,grey]      %s              #s2
%s      #f_ip(li2)
MDRP[min,rnd,grey]      %s              #s3
""" % (vstem_c1(t1,thin=True),s2,f_ip(li2),s3,)


#================================================
def hf_sara_a(s0, s1,s1s, s2,s2s, li, s3,s3s, g1="gap_102"):
    return """
SRP0                    %s          #s0
MIRP[rp0,rnd,white]     %s %s       #g1,s1
ALIGNRP                 %s          #s1s
%s      #h_head(s1,s2,li,headtype="sara_a")
SHP[rp2]                %s          #s2s
MDRP[rnd,grey]          %s          #s3
SHP[rp2]                %s          #s3s
%s      #h_exp_head(li[3],li[4],headtype="sara_a")
%s      #dry upper head
#ax#SHPIX           24 %s   #li[2]+1
#ax#SHPIX           24 %s   #li[5]+1
""" % (s0,g1,s1,s1s, h_head(s1,s2,li,headtype="sara_a"),s2s, s3,s3s,h_exp_head(li[3],li[4],headtype="sara_a"),  f_dstr_dict({
    s1s+2:"14+3 15+3 16+3 ",
    s2s-2:"14-3 15-3 16-3 ",
    s2s+2:"14-6 15-5 16-4 ",
    },aip="#ax#"),
li[2]+1,li[5]+1,)


def vm_sara_a(s0, s1, s2,li2, s3,s4,li4, s5):
    return "\n".join([""
        , "MDAP[rnd]               %s          #s0" % (s0,)
        , f_stem(s0,s1,stem="v_kho_khai",type="+",thin=True)
        , v_head(s0,s2,li2,headtype="sara_a_bottom_up")
        , vr1(s3,move_rp0=True)
        , v_head(s3,s4,li4, move_rp0=True,headtype="sara_a_top_down")
        , f_stem(s4,s5,stem="v_kho_khai",type="+",thin=True)
    ])


#..............................
def vr_2(s0,s1,add1, s2, li, add2, s3):
    return """
MDAP[rnd]               %s              #s0
MDRP[rp0,min,rnd,grey]  %s              #s1     %s  #add1
%s          #v_head(s1,s2,li,headtype="sara_u",move_rp0=True) %s    add2
MDRP[min,rnd,grey]      %s              #s3
""" % (s0,s1,add1, v_head(s1,s2,li,headtype="sara_u",move_rp0=True), add2, s3,)


#....................
def vr_sara_u(s0,s1,s2, li, s3):
    add1 = add2 = ""
    return vr_2(s0,s1,add1,s2, li, add2, s3)


def vr_sara_uu(s0, s1,s1s, s2, li, s2s, s3):
    add1 = """
ALIGNRP                 %s              #s1s
""" % (s1s,)
    add2 = """
ALIGNRP                 %s              #s2s
""" % (s2s,)
    return vr_2(s0,s1,add1,s2, li, add2, s3) + """
SHPIX                   -16 %s
""" % (s2s,) + f_dstr(s2s,"20+4 21+4 22+4 23+4 24+4 25+4 26+4 27+4 ")


#..............................
def hf_mai_hanakat(sr,s1,s2, li, s3):
    return """
MDAP[rnd]               %s              #sr
MDRP[rp0,rnd,grey]      %s              #s1
%s      #h_head(s1,s2,li,headtype="mai_hanakat")
MDRP[rnd,grey]          %s              #s3
""" % (sr, s1, h_head(s1,s2,li,headtype="mai_hanakat"), s3,)

def vm_mai_hanakat(s0,sr,s1,s2, s3, li):
    return """
MDAP[rnd]               %s              #s0
MIRP[rp0,rnd,grey]      vheight_shoot %s #sr
MDRP[rp0,min,rnd,grey]  %s              #s1
%s      #f_stem(s1,s2,stem="v_kho_khai",type="+",thin=True)
%s      #v_head(s1,s3, li, headtype="mai_hanakat")    
SHPIX                   8 %s            #s1
""" % (s0,sr, s1, f_stem(s1,s2,stem="v_kho_khai",type="+",thin=True), v_head(s1,s3, li, headtype="mai_hanakat"),s1,)


#..............................
def hr_phinthu(s1,s2):
    return """
MDAP[rnd]               %s              #s1
MDRP[min,rnd,grey]      %s              #s2
""" % (s1,s2,)


def vr_phinthu(s0,s1,s2):
    return """
MDAP[rnd]               %s              #s0
MDRP[rp0,min,rnd,white] %s              #s1
MDRP[min,rnd,grey]      %s              #s2
""" % (s0,s1,s2,)


#..............................
def hf_baht(s0,s1, s2,s2s, s3,s3s1,s3s2,s3s3, s4,s4s1,s4s2,s4s3, s5,s6,s7,s8):
    add1 = """
f_deltap    %s 9-8  %s 10-8  %s 20-8
""" % (s1, s1, s1,)
    temp = """
f_deltap    %s 15+8  %s 16+8  %s 24+8  %s 25+8
"""
    add3 = temp % (s3,s3,s3,s3,)
    add5 = temp % (s5,s5,s5,s5,)

    return """
SRP0                    %s              #s0
MDRP[rp0,rnd,white]     %s              #s1     %s  #add1
MIRP[rp0,min,rnd,grey]  hstem %s        #s2
ALIGNRP                 %s              #s2s
MDRP[rp0,min,rnd,white] %s              #s3     %s  #add3
ALIGNRP                 %s              #s3s1
ALIGNRP                 %s              #s3s2
ALIGNRP                 %s              #s3s3
MDRP[rp0,min,rnd,grey]  %s              #s4
ALIGNRP                 %s              #s4s1
ALIGNRP                 %s              #s4s2
ALIGNRP                 %s              #s4s3
MDRP[rp0,min,rnd,grey]  %s              #s5     %s  #add5
MIRP[min,rnd,grey]      hstem %s        #s6
MDRP[rp0,rnd,grey]      %s              #s7
MIRP[min,rnd,grey]      hstem %s        #s8
""" % (s0,s1,add1, s2,s2s, s3,add3,s3s1,s3s2,s3s3, s4,s4s1,s4s2,s4s3, s5,add5,s6,s7,s8)

def vm_baht(s0,s0s, l0, s1,s1s, s2,s2s, t2, s3,s3s, s4,s4s, s5,s5s, i451):
    return """
MDAP[rnd]               %s              #s0
ALIGNRP                 %s              #s0s
MDRP[min,rnd,grey]      %s              #l0
%s                                  #vstem_c1s(s1,s1s)
MDRP[rp0,rnd,grey]      %s              #s2
ALIGNRP                 %s              #s2s
MDRP[min,rnd,grey]      %s              #t2
%s                                  #vstem_c2s(s3,s3s)
SRP1                    %s              #s2
SRP2                    %s              #s1
IP                      %s              #s4
MDAP[rnd]               %s              #s4
ALIGNRP                 %s              #s4s
%s                                  #vstem_c2s(s5,s5s)
IP                      %s              #i451
""" % (s0,s0s, l0, vstem_c1s(s1,s1s),s2,s2s,t2,vstem_c2s(s3,s3s),s2,s1,s4,s4,s4s,vstem_c2s(s5,s5s),i451,)


#..............................
def vm_sara_o(s1,s2, s3,li,s4):
    return """
MDAP[rnd]               %s              #s1
%s          #vstem_c1(s2)
MDRP[rp0,rnd,grey]      %s              #s3
%s          #f_ip(li)
MDRP[grey]              %s              #s4
SHPIX                   -12 %s          #s4
""" % (s1,vstem_c1(s2,thin=True), s3,f_ip(li),s4,s4)

#..............................
def hf_sara_ai_maimuan(s0,s1,s2, li, s3,s4):
    return """
SRP0                    %s              #s0
MDRP[rp0,rnd,white]     %s              #s1
MDRP[rp0,rnd,grey]      %s              #s2
f_deltap    %s 21-8 %s 26-8 %s 30-8 %s 31-8
%s      #f_ip(li)
SHPIX                   -16 %s          #li[2]
MDRP[rp0,min,rnd,white] %s              #s3
MIRP[min,rnd,grey]      hstem %s        #s4
SHPIX                   16 %s           #s3
SHPIX                   8 %s            #s1
SHPIX                   -8 %s           #s2
#ax#SHPIX               -16 %s          #li[2]+1
""" % (s0, s1,s2, s2,s2,s2,s2, f_ip(li), li[2],s3,s4,s3, s1,s2,li[2]+1,)

def vm_sara_ai_maimuan(s1,s2,s3,s4, li):
    return """
MDAP[rnd]               %s              #s1
%s      #vstem_c1(s2,thin=True)
MDRP[rp0,rnd,grey]      %s              #s3
f_deltap    %s 9+8 %s 10+8 
MDRP[rnd,grey]          %s              #s4
%s      #f_ip(li)
SHPIX                   -8 %s           #s3
SHPIX                   8 %s            #s4
""" % (s1, vstem_c1(s2,thin=True), s3,s3,s3, s4, f_ip(li), s3,s4,) 


#..............................
def hadd_sara_ai_maimalai(s1, s2, i2,s0,s0s):
    return """
MDRP[rp0,min,rnd,grey]  %s              #s1
MDRP[min,rnd,grey]      %s              #s2
IP                      %s              #i2
SRP0                    %s              #s0
ALIGNRP                 %s              #s0s
""" % (s1,s2, i2, s0,s0s)


def vm_sara_ai_maimalai(s1,s2, t1 ,s3,s4):
    return """
MDAP[rnd]               %s              #s1
MDRP[min,rnd,grey]      %s              #s2
SHPIX                   24 %s           #s2
MDRP[min,rnd,grey]      %s              #t1
MDRP[rp0,rnd,grey]      %s              #s3
MDRP[min,rnd,grey]      %s              #s4
SHPIX                   -24 %s          #s4
""" % (s1, s2,s2,t1,s3,s4,s4,)


#..............................
def hr_maitaikhu(s1,t1, s2, li, s3,s4):
    return """
MDAP[rnd]               %s              #s1
MDRP[min,rnd,grey]      %s              #t1
MDRP[rnd,grey]          %s              #s2
%s          #f_deltap-s2
%s          #f_ip(li)
MDRP[rp0,rnd,grey]      %s              #s3
MDRP[min,rnd,grey]      %s              #s4
SHPIX                   8 %s            #s3
SHPIX                   -16 %s          #s4
%s          #f_deltap-li[0]
""" % (s1,t1,s2,
    f_dstr(s2,"13+8 14+8 22+4 23+4"),
    f_ip(li), s3,s4,s3,s4,
    f_dstr(li[0],"12+4 13+4 14+4 "),)

def vm_maitaikhu(s1,s1s,s2,li2, s3,li3, s4,s5):
    return """
MDAP[rnd]               %s              #s1
ALIGNRP                 %s              #s1s
MDRP[rnd,grey]          %s              #s2
%s          #f_deltap-s2
%s          #f_ip(li2)
MDRP[rp0,rnd,grey]      %s              #s3
%s          #f_ip(li3)
MDRP[rp0,min,rnd,white] %s              #s4
MDRP[min,rnd,grey]      %s              #s5
SHPIX                   -8 %s           #s5
SHPIX                    8 %s           #s4
SHPIX                   -16 %s          #li2[2]
SHPIX                   -16 %s          #li3[0]
SHPIX                    8 %s           #li3[1]
""" % (s1,s1s,s2,
    f_dstr(s2,"12-4 13-5 14-4 20-8 21-8 22-8 23-8 28-8 "),
    f_ip(li2), s3,f_ip(li3), s4,s5,s5,s4, li2[2],li3[0],li3[1],)


#..............................
def hr_mai_ek(s1,s2):
    return """
MDAP[rnd]               %s              #s1
MDRP[min,rnd,grey]      %s              #s2
SHPIX                   8 %s            #s2
SHPIX                   -8 %s           #s1
""" % (s1,s2,s2,s1,)

def vm_mai_ek(s1,s2):
    return """
MDAP[rnd]               %s              #s1
MDRP[min,rnd,grey]      %s              #s2
""" % (s1,s2,)


#..............................
def hr_mai_tho(s1, t1, s2,s2s, li):
    return """
MDAP[rnd]               %s              #s1
MDRP[rnd,grey]          %s              #t1
MDRP[rnd,grey]          %s              #s2
SHP[rp2]                %s              #s2s
%s      #f_ip(li)
SHPIX                   -16 %s          #li[3]
#ax#SHPIX               24 %s           #li[3]+2
#ax#SHPIX               16 %s           #li[2]
""" % (s1, t1,s2,s2s, f_ip(li),li[3],li[3]+2,li[2])

def vm_mai_tho(s1,s2,s2s, s3, s4, li):
    return """
MDAP[rnd]               %s              #s1
MDRP[rp0,min,rnd,grey]  %s              #s2
MDRP[rp0,rnd,grey]      %s              #s3
MDRP[rnd,grey]          %s              #s4
%s      #f_deltap-s4
%s      #f_ip(li)
SHPIX                   -8 %s           #s2
SRP0                    %s              #s2
ALIGNRP                 %s              #s2s
SHPIX                   8 %s            #s1
""" % (s1,s2,s3,s4, 
    f_dstr(s4,"13+8 14+8 15+8 16+8 17+4 "),
    f_ip(li), s2,s2,s2s,s1,)


#..............................
def hr_mai_tri(s1,t1, s2, li2, s3, li3):
    return """
MDAP[rnd]               %s              #s1
MDRP[min,rnd,grey]          %s              #t1
MDRP[rp0,rnd,grey]      %s              #s2
%s      #f_ip(li2)
MDRP[rp0,rnd,grey]      %s              #s3
%s      #f_deltap-s3
%s      #f_ip(li3)
SHPIX                   -8 %s           #s1
SHPIX                   -8 %s           #li2[0]
SHPIX                    8 %s           #li2[1]
%s      #f_deltap-li2
""" % (s1,t1,s2, f_ip(li2), s3,
    f_dstr(s3,"10-6 11-6 12-6 17-4 18-4 19-4 23-8 "),
    f_ip(li3), s1, li2[0],li2[1],
    f_dstr_dict({
        li2[0]:"10+2 11+2 12+2",
        li2[1]:"10-3 11-3 12-3" }) ,)

def vm_mai_tri(s1,s1s,s2,li2, s3,s3s,li3,t3):
    return """
MDAP[rnd]               %s              #s1
ALIGNRP                 %s              #s1s
MDRP[min,rnd,grey]      %s              #s2
%s      #f_deltap-s2
%s      #f_ip(li2)
MDRP[rp0,rnd,grey]      %s              #s3
ALIGNRP                 %s              #s3s
%s      #f_ip(li3)
MDRP[min,rnd,grey]      %s              #t3
""" % (s1,s1s,s2, 
    f_dstr(s2,"13-4 14-4 15-4 16-4 17-4 22-8 23-4 "),
    f_ip(li2), s3,s3s, f_ip(li3),t3,)


#..............................
def hr_mai_chattawa(s1,s1s,s2,s2s):
    return """
MDAP[rnd]               %s              #s1
ALIGNRP                 %s              #s1s
MDRP[grey]              %s              #s2
SHP[rp2]                %s              #s2s
#ax#SHPIX               -16 %s          #s1
#ax#SHPIX               16 %s           #s2
""" % (s1,s1s,s2,s2s,s1,s2,)

def vm_mai_chattawa(s1,s2,s2s,s3,s3s):
    return """
MDAP[rnd]               %s              #s1
MDRP[rp0,min,rnd,grey]  %s              #s2
ALIGNRP                 %s              #s2s
MDRP[grey]              %s              #s3
SHP[rp2]                %s              #s3s
#ax#SHPIX               16 %s           #s2
#ax#SHPIX               -16 %s          #s3s
""" % (s1,s2,s2s,s3,s3s,s2,s3s,)


#..............................
def hr_thanthakhat(s1,t1,s2, li):
    return """
MDAP[rnd]               %s              #s1
MDRP[rnd,grey]          %s              #t1
MDRP[rnd,grey]          %s              #s2
%s      #f_deltap-s2
%s      #f_ip(li)
""" % (s1,t1, s2, 
    f_dstr(s2,"10+4 11+3 16-4 "),
    f_ip(li),)


def vm_thanthakhat(s1,s2, li, s3):
    return """
MDAP[rnd]               %s              #s1
%s          #head0(s2, li, move_rp0=True)
MDRP[grey]              %s              #s3
""" % (s1, head0(s2,li,move_rp0=True), s3,)


#..............................
def hr_yamakkan(s1,s2, li, s3, i231, s4,s5):
    return """
MDAP[rnd]               %s              #s1
MDRP[rp0,rnd,grey]      %s              #s2
%s      #f_ip(li)
MDRP[grey]              %s              #s3
IP                      %s              #i231
MDRP[rp0,rnd,grey]      %s              #s4
MDRP[grey]              %s              #s5
%s      #dx_1(s2)
%s      #dx_1(s4)
""" % (s1,s2, f_ip(li),s3,i231,s4,s5,dx_1(s2),dx_1(s4),)


def vm_yamakkan(s1,s2,li):
    return """
MDAP[rnd]               %s          #s1
MDRP[rp0,rnd,grey]      %s          #s2
%s          #f_ip(li)
""" % (s1,s2, f_ip(li),)
#def vm_yamakkan(s1,s2,s3,s4,i341,s5,s6):
#    return """
#MDAP[rnd]               %s              #s1
#MDRP[rp0,rnd,grey]      %s              #s2
#MDRP[rp0,rnd,white]     %s              #s3
#MDRP[rp0,rnd,grey]      %s              #s4
#IP                      %s              #i341
#MDRP[rp0,rnd,white]     %s              #s5
#MDRP[rp0,rnd,grey]      %s              #s6
#%s      #dx_1(s2)
#%s      #dx_1(s4)
#%s      #dx_1(s6)
#%s      #dx_2(s1)
#%s      #dx_2(s3)
#%s      #dx_2(s5)
#""" % (s1,s2,s3,s4,i341,s5,s6, dx_1(s2),dx_1(s4),dx_1(s6),dx_2(s1),dx_2(s3),dx_2(s5),)


#..............................
def hv_fongman(s1,s2,s3,s4,s5,s6,s7,s8):
    return """
MDAP[rnd]               %s              #s1
MDRP[rp0,min,rnd,grey]  %s              #s2
MDRP[rp0,min,rnd,white] %s              #s3
SRP0                    %s              #s1
MDRP[rp0,rnd,grey]      %s              #s8
MDRP[rp0,min,rnd,grey]  %s              #s7
MDRP[rp0,min,rnd,white] %s              #s6
SRP1                    %s              #s3
SRP2                    %s              #s6
IP                      %s              #s4
IP                      %s              #s5
""" % (s1,s2,s3,s1,s8,s7,s6,s3,s6,s4,s5,)

#..............................

#..............................

#================================================
pseudo_code_dict = {

    'uni0E01':      #KO KAI
        packline(""
        #, hf_ko_kai(26,14,18,8, 12,10,17)
        , hf_ko_kai(26,14,18,17, 12,10,8)
        , hr_ko_kai(27,25, 1)
        , add_ip(12,1,[22,5])
        , ix()
        #y
        , sy()
        , v0s(1,13)
        , vtc1_ko_kai(22, [17,18,19,8,9,10])
        , vstem_c1(5)
        , iy()
        ),

    'uni0E02':    #KHO KHAI
        packline(""
        , hf_kho_khai(53, 21,15, [50,44,12])
        , hr_kho_khai(54, 38,36, 32,1, 27,7)
        , ix()
        #y
        , sy()
        , vb0(0,34)
        , vr1(38)
        , vf_kho_khai(24,10,12,18, [47,41])
        , iy()
        ),

    'uni0E03':    #KHO KHUAT
        packline(""
        , hf_kho_khuat(57, 24,18, [55,48,13])
        , hr_kho_khuat(58, 42,40, 37,1, 31,7)
        , add_ip(24,31, [27,28,29,9,10,11])
        , ix()
        #y
        , sy()
        , vb0(0,38)
        , vr1(42)
        , vf_kho_khuat(29,27, 9,11, 10,28, 15,21, [51,45])
        , iy()
        ),

    'uni0E04':    #KHO KHWAI
        packline(""
        , hf_kho_khwai(51,32,8, 29,28, 14,11, 20, [48,42,25])
        , hr_kho_khwai(52,38,1)
        , ix()
        #y
        , sy()
        , v0s(1,28)
        , vtc1(35, [11])
        , vstem_c1(5,thin=2)
        , vmh_kho_khwai(17,23, [45,39])
        , iy()
        , groove_1(11)
        , groove_2(25)
        ),

    'uni0E05':    #KHO KHON
        packline(""
        , hf_kho_khwai(56,35,11, 32,31, 17,14, 23, [53,47,28])
        , hr_kho_khwai(57,43,1)
        , add_ip(11,1, [38,39,40,5,6,7,8])
        , ix()
        #y
        , sy()
        , v0s(1,31)
        , vtc1s_kho_khon(40,38, [14])
        , vstem_c1s(5,8)
        , vm3(6,39)
        , vmh_kho_khon(20,26, [50,44,28])
        , groove_1(6)
        , iy()
        , groove_1(14)
        , groove_2(28)
        ),

    'uni0E06':    #KHO RAKHANG
        packline(""
        , hf_kho_khuat(79, 37,31, [64,58,26])
        , hr_kho_rakhang(80, 54,52,1, 49,3, 14, 9, [76,70], 44,20)
        , ix()
        #y
        , sy()
        , vb0(1,52)
        , vr1(54)
        , vf_kho_khuat(42,40, 22,24, 23,41, 29,34, [61,55])
        , vb0l_mo_ma(1,6,12, [73,67,50,3])
        , iy()
        ),

    'uni0E07':    #NGO NGU
        packline(""
        , hf_ngo_ngu(37,4)
        , hr_ngo_ngu(38,22,11, 17, [34,28], 1,8)
        , ix()
        #y
        , sy()
        , vb0(0,9)
        , vf_no_nu(20,14, [31,25])
        , iy()
        ),

    'uni0E08':    #CHO CHAN
        packline(""
        , hf_cho_chan(44,22,7,12, [41,35,2])
        , hr_cho_chan(45,29,16,1,0,13)
        , ix()
        , hadd_cho_chan(11,13, 12, 2)
        #y
        , sy()
        , vb0(0,13)
        , vtc1(26)
        , vstem_c1(19,thin=1)
        , vmh_cho_chan(10,4, [38,32])
        , v_end_front_spline(19,22)
        , iy()
        , groove_1(13)
        ),

    'uni0E09':    #CHO CHING
        packline(""
        , hf_cho_ching(67,7,22, 12,0, [52,46], 1)
        , hr_no_nu(68,33,39, [62,56], 29, 15)
        , ix()
        #y
        , sy()
        , vb0(0,13)
        , vtc1(26)
        , vstem_c1(19,thin=1)
        , vmh_cho_chan(10,4, [49,43])
        , vb0l_mo_ma(0,36,30, [61,55,15,41])
        , v_end_front_spline(19,22)
        , iy()
        , notch_1(23)
        ),

    'uni0E0A':    #CHO CHANG
        packline(""
        , hf_kho_khai(62, 21,15, [59,53,12])
        , hr_cho_chang(63, 47,36, 43,42, 32,1, 27,7, 39,45)
        , ix()
        #y
        , sy()
        , vb0(0,34)
        , vfr_cho_chang(24, [39,40,45],43, 10,12,18, [56,50])
        , iy()
        ),

    'uni0E0B':    #SO SO
        packline(""
        , hf_kho_khuat(66, 24,18, [63,57,13])
        , hr_so_so(67, 51,40, 47,46, 36,1, 31,7, 43,49)
        , add_ip(24,31, [27,28,29,9,10,11])
        , ix()
        #y
        , sy()
        , vb0(0,38)
        , vfr_so_so(27,29, [44,43,49], 46, 9,11, 10,28, 15,21, [60,54])
        , iy()
        ),

    'uni0E0C':    #CHO CHOE
        packline(""
        , hf_tho_thung(77,36,40,21, 25,23,39, 31, [62,56])
        , hr_cho_choe(78,52,50,1, 47,14, 11,5, [74,68])
        , add_ip(25,14,[44,18])
        , ix()
        #y
        , sy()
        , vb0(1,50,thin=True)
        , vr1(52)
        , vtc1_ko_kai(44, [39,40,41,21,22,23,46,16])
        , vstem_c1(18,thin=1)
        , vb0l_cho_choe(1,34,8, 28,14, [59,53,71,65,48,3])
        , '\nf_deltap   50 14+4\n'
        , iy()
        ),

    'uni0E0D.descless': #YO YING
        packline(""
        , hf_tho_thung(51,23,27,8, 12,10,26, 18, [48,42])
        , hr_yo_ying(52,38,36,34,1)
        , add_ip(12,1,[31,5])
        , ix()
        #y
        , sy()
        , vb0(1,35)
        , vr1(38)
        , vtc1_ko_kai(31, [26,27,28,8,9,10,3,33])
        , vstem_c1(5,thin=1)
        , vb0l_head(1,21,15, [45,39])
        , iy()
        ),

    'desc.uni0E0D':
        packline(""
        , mdap(16,"10-8 15+8 19+8 20+8 21+8 22-8 31+8 34-8 ")
        , mdrp0rg(3)
        , mdrprg(9,"10-8 11-8 ")
        , f_ip([28,22])
        , ix()
        #y
        , sy()
        , mdap(31)
        , mdrp0mrw(6)
        , "ALIGNRP  15"
        , mdrp0rg(0,"9+8 15+8 16+8 21+8 ")
        , f_ip([25,19])
        , mdrpg(11)
        , iy()
        ),

    'uni0E0E':    #DO CHADA
        packline(""
        , hf_pho_samphao(74,35,29, [61,55], 27,43, 40,44,25)
        , hr_do_chada(75,51,18,1, 8, 71, [66,13,3,16])
        , add_ip(29,18,[48,22])
        , ix()
        , notch_2(66)
        , notch_1(16)
        #y
        , sy()
        , v0(74)
        , vtc1_ko_kai(48, [43,44,45,25,26,27,20,50])
        , vstem_c1(22,thin=1)
        , vb0l_head(74,32,38, [58,52])
        , vl_do_chada(74,5,1, 18, 11, [16,68,64,3])
        , iy()
        , notch_2(3)
        , notch_1(13)
        , groove_1(18)
        ),

    'uni0E0F':    #TO PATAK
        packline(""
        , hf_pho_samphao(78,41,35, [67,61], 33,49, 46, 50,31)
        , hr_do_chada(79,57,24,1, 11,76, [72,16,6,19,21,2])
        , add_ip(35,24,[54,28])
        , ix()
        , notch_2(72)
        , notch_1(19)
        #y
        , sy()
        , v0(78)
        , vtc1_ko_kai(54, [49,50,51,31,32,33,26,56])
        , vstem_c1(28,thin=1)
        , vb0l_head(78,38,44, [64,58])
        , vl_to_patak(78,8, 4,1, 24,21, 14, [16,74,70,6])
        , iy()
        , groove_2(2)
        , notch_2(6)
        , notch_1(16)
        , groove_1(24)
        , groove_1(21)
        ),

    'uni0E10.descless':    #THO THAN
        packline(""
        , hf_tho_than(59,19,41, 7, 12, [56,50,2])
        , hr_tho_than(60,44,31,16, 1,0,13)
        , ix()
        , hadd_cho_chan(11,13, 12, 2)
        #y
        , sy()
        , vb0(0,13)
        , vtc1(23)
        , vstem_c1(38,thin=2)
        , vmh_tho_than(10, [20,41,19,17], 4, [53,47], 43)
        , iy()
        , groove_1(13)
        ),

    'desc.uni0E10':
        packline(""
        , mdap(37)
        , mdrpg(26)
        , mdrprg(32)
        , f_ip([47,41])
        , mdrprg(11)
        , f_ip([56,52,21,23,2])
        , ix()
        #y
        , sy()
        , mdap(58)
        , mdrp0mrw(35)
        , mdrp0rg(29)
        , f_ip([44,38])
        , mdrp0rg(1)
        , "ALIGNRP 3"
        , "ALIGNRP 8"
        , f_ip([25,2,23])
        , mdrprg(14)
        , f_ip([54,50,16,6])
        , iy()
        ),

    'uni0E11':    #THO NANGMONTHO
        packline(""
        , hf_kho_khuat(66, 33,27, [63,57,22])
        , hr_tho_nangmontho(67, 53,1, 45,9, 10, 40, 49, 16, 6)
        , ix()
        #y
        , sy()
        , vsb0(1,9,46)
        , vfr_tho_nangmontho(38,36, 51,4, 18,20, 19,37, 24,30, [60,54])
        , iy()
        ),

    'uni0E12':    #THO PHUTHAO
        packline(""
        , hf_do_dek(82,44,22, 41,40,25, 31,37, [67,61,28])
        , hr_tho_phuthao(83,57,55,1, 52,14,11,5, [79,73])
        , ix()
        #y
        , sy()
        , vsb0s(1,40, 55,25,thin=True)
        , vr1(57)
        , vtc1s_to_tao(49,47)
        , vstem_c1s(17,20)
        , vm3(18,48)
        , vmh_do_dek(34,28, [64,58])
        , vb0l_mo_ma(1,8,14, [76,70,53,3])
        , iy()
        ),

    'uni0E13':    #NO NEN
        packline(""
        , hf_tho_thung(77,23,27,8, 12,10,26, 18, [62,56])
        , hr_no_nu(78,43,51, [74,68], 39, 37)
        , hadd_no_nen(34,0, 1)
        , add_ip(12,1,[31,5])
        , ix()
        #y
        , sy()
        , vb0(1,35)
        , vr1(39)
        , vtc1_ko_kai(31, [26,27,28,8,9,10,3,33])
        , vstem_c1(5,thin=1)
        , vb0l_cho_choe(1,21,46, 15,40, [59,53,71,65,37,51])
        , iy()
        ),

    'uni0E14':    #DO DEK
        packline(""
        , hf_do_dek(49,30,8, 27,26,11, 17,23, [46,40,14])
        , hr_kho_khwai(50,36,1)
        , ix()
        #y
        , sy()
        , vsb0(1,26, 11)
        , vtc1(33)
        , vstem_c1(5,thin=2)
        , vmh_do_dek(20,14, [43,37],add1="\nf_deltap 20 9-8\n")
        , iy()
        , groove_1(11)
        ),

    'uni0E15':    #TO TAO
        packline(""
        , hf_do_dek(52,31,9, 28,27,12, 18,24, [49,43,15])
        , hr_kho_khwai(53,39,1)
        , ix()
        , dx_2(15)
        #y
        , sy()
        , vsb0(1,27, 12)
        , vtc1s(36,34)
        , vstem_c1s(4,7)
        , vm3(5,35)
        , vmh_do_dek(21,15, [46,40])
        , groove_1(5)
        , iy()
        , groove_1(12)
        ),

    'uni0E16':    #THO THUNG
        packline(""
        , hf_tho_thung(47,23,27,8, 12,10,26, 18,[44,38])
        , hr_ko_kai(48,33, 1)
        , add_ip(12,1,[31,5])
        , ix()
        #y
        , sy()
        , v0(1)
        , vtc1_ko_kai(31, [26,27,28,8,9,10,33,3])
        , vstem_c1(5)
        , vb0l_head(1,21,15, [41,35])
        , iy()
        ),

    'uni0E17':    #THO THAHAN
        packline(""
        , hf_tho_thahan(40,15, 20,8, [37,31], 9)
        , hr_tho_thahan(41,27,1)
        , hadd_tho_thahan(20,1, 23, 6)
        , ix()
        #y
        , sy()
        , v0s(1,8)
        , vfr_tho_thahan(18,25, [21], 4, 12, [34,28])
        , iy()
        , groove_1(21)
        ),

    'uni0E18':    #THO THONG
        packline(""
        , hf_tho_thong(39,11,33, 1,3)
        , hr_tho_thong(40,36,23,7)
        , ix()
        #y
        , sy()
        , vb0(0,5)
        , vtc1(15)
        , vstem_c1(30,thin=2)
        , vmh_tho_thong(2, [12,11,33,35], 9)
        , iy()
        ),

    'uni0E19':    #NO NU
        packline(""
        , hf_tho_thahan(55,7, 12,0, [40,34], 1)
        , hr_no_nu(56,21,27, [52,46], 17, 15)
        , ix()
        #y
        , sy()
        , vb0(0,13)
        , vr1(17)
        , vf_no_nu(10,4, [37,31])
        , vb0l_mo_ma(0,24,18, [15,29,49,43])
        , iy()
        , groove_1(13)
        ),

    'uni0E1A':    #BO BAIMAI
        packline(""
        , hf_bo_baimai(35,9, 14, [32,26], 3, 1)
        , hr_bo_baimai(36,20,18)
        , ix()
        #y
        , sy()
        , vb0s(0,15, 3)
        , vr1(20)
        , vf_no_nu(12,6, [29,23])
        , iy()
        ),

    'uni0E1B':    #PO PLA
        packline(""
        , hf_bo_baimai(35,9, 14, [32,26], 3, 1)
        , hr_bo_baimai(36,20,18)
        , ix()
        #y
        , sy()
        , vb0s(0,15, 3)
        , vr1_po(20)
        , vf_no_nu(12,6, [29,23])
        , iy()
        ),

    'uni0E1C':    #PHO PHUNG
        packline(""
        , hf_pho_phung(34,4, 15,3, 10, [31,25])
        , hr_mo_ma(35,21,19,1)
        , add_ip(15,19, [17,18,2])
        , ix()
        #y
        , sy()
        , vbs1s(1,3, 19,16)
        , vr1(21)
        , vf_no_nu(7,13, [28,22])
        , add_ip(13,1, [18,2])
        , iy()
        , groove_2(2)
        ),

    'uni0E1D':    #FO FA
        packline(""
        , hf_pho_phung(34,4, 15,3, 10, [31,25])
        , hr_mo_ma(35,21,19,1)
        , add_ip(15,19, [17,18,2])
        , ix()
        #y
        , sy()
        , vbs1s(1,3, 19,16)
        , vr1_po(21)
        , vf_no_nu(7,13, [28,22])
        , add_ip(13,1, [18,2])
        , iy()
        , groove_2(2)
        ),

    'uni0E1E':    #PHO PHAN
        packline(""
        , hf_pho_phan(34,10,15, [31,25], 4)
        , hr_ko_kai(35,21,19)
        , hadd_pho_phan(15,19, [1,2,3], 17,18)
        , ix()
        #y
        , sy()
        , v0s(1,3)
        , vr1(21)
        , vf1(13, [17,2,16,19], 7, [28,22])
        , f_dstr(2,"14+2 15+1 16+5")
        , iy()
        , groove_1(19)
        , groove_1(16)
        ),

    'uni0E1F':    #FO FUN
        packline(""
        , hf_pho_phan(34,10,15, [31,25], 4)
        , hr_ko_kai(35,21,19)
        , hadd_pho_phan(15,19, [1,2,3], 17,18)
        , ix()
        #y
        , sy()
        , v0s(1,3)
        , vr1_po(21)
        , vf1(13, [17,2,16,19], 7, [28,22])
        , f_dstr(2,"14+2 15+1 16+5")
        , iy()
        , groove_1(19)
        , groove_1(16)
        ),

    'uni0E20':    #PHO SAMPHAO
        packline(""
        , hf_pho_samphao(47,18,12, [44,38], 10,26, 23, 27,8)
        , hr_ko_kai(48,34,1)
        , add_ip(12,1,[31,5])
        , ix()
        #y
        , sy()
        , v0(1)
        , vtc1_ko_kai(31, [26,27,28,8,9,10,3,33])
        , vstem_c1(5)
        , vb0l_head(1, 15,21, [41,35])
        , iy()
        ),

    'uni0E21':    #MO MA
        packline(""
        , hf_mo_ma(55, 20,9, 25,3, [40,34,52,46], 14)
        , hr_mo_ma(56, 30,28, 1)
        , ix()
        #y
        , sy()
        , vb0(1,28,thin=True)
        , vr1(30)
        , vf_no_nu(23,17, [37,31])
        , vb0l_mo_ma(1,6,12, [26,49,3,43])
        , "\nf_deltap 3 13+2 3 14+2 3 15+2 3 16+2\n"
        , iy()
        ),

    'uni0E22':    #YO YAK
        packline(""
        , hf_yo_yak(50, 7,21, 19, 13, [47,41], 2,29, 26, 4)
        , hr_yo_yak(51,35,33)
        , ix()
        , f_dstr(23,"14-6 15-6 16-6")
        #y
        , sy()
        , vb0(0,31)
        , vr1(35)
        , vf_no_nu(10,16, [44,38,19])
        , vadd_yo_yak(16,0, 26, 25, 4)
        , iy()
        ),

    'uni0E23':    #RO RUA
        packline(""
        , hf_ro_rua(52,12,34)
        , hr_ro_rua(53,37,8, 3, [49,43], 24)
        , ix()
        #y
        , sy()
        , v0(52)
        , vtc1(16)
        , vstem_c1(31,thin=1)
        , vb0l_head(52,0,6, [46,40])
        , add_ip(16,6, [10,12,13,34,36])
        , "\nf_deltap 10 12+2\n"
        , notch_1(36)
        , iy()
        , notch_2(24)
        ),

    'uni0E24':    #RU
        packline(""
        , hf_tho_thung(47,23,27,8, 12,10,26, 18, [44,38])
        , hr_ko_kai(48,34, 1)
        , add_ip(12,1,[31,5])
        , ix()
        #y
        , sy()
        , vl0_ru(47,1)
        , vtc1_ko_kai(31, [26,27,28,8,9,10,3,33])
        , vstem_c1(5)
        , vb0l_head(47,21,15, [41,35])
        , iy()
        ),

    'uni0E25':    #LO LING
        packline(""
        , hf_lo_ling(51,17,6, 31, 12, [48,42])
        , hr_mo_ma(52,38,24, 1)
        , add_ip(5,24, [21,4])
        , ix()
        , notch_1(23)
        #y
        , sy()
        , v0(1)
        , vtc1(35, [21,24])
        , vstem_c1(28,thin=2)
        , vb0l_head(1,15,9, [45,39])
        , vadd_lo_ling(21,4)
        , v_end_front_spline(28,31)
        , iy()
        , groove_1(24)
        , "\nf_deltap 24 16-8\n"
        ),

    'uni0E26':    #LU
        packline(""
        , hf_pho_samphao(47,18,12, [44,38], 10,26, 23, 27,8)
        , hr_ko_kai(48,34,1)
        , add_ip(12,1,[31,5])
        , ix()
        #y
        , sy()
        , vl0_ru(47,1)
        , vtc1_ko_kai(31, [26,27,28,8,9,10,3,33])
        , vstem_c1(5)
        , vb0l_head(47, 15,21, [41,35])
        , iy()
        ),

    'uni0E27':    #WO WAEN
        packline(""
        , hf_wo_waen(37,15)
        , hr_wo_waen(38,22,8, 3, [34,28])
        , ix()
        #y
        , sy()
        , v0(37)
        , vtc1(19)
        , vstem_c1(12)
        , vb0l_head(37,0,6, [31,25])
        , v_end_front_spline(12,15)
        , iy()
        ),

    'uni0E28':    #SO SALA
        packline(""
        , hf_kho_khwai(63,38,14, 35,34, 20,17, 26, [60,54,31])
        , hr_so_sala(64,50,1)
        , ix()
        , notch_1(32)
        , notch_1(48)
        , notch_2(9)
        #y
        , sy()
        , v0s(1,34)
        , vtc1(41, [17])
        , vstem_c1(11,thin=2)
        , vmh_kho_khwai(23,29, [57,51,31])
        , iy()
        , groove_1(17)
        , groove_2(31)
        , notch_1(43)
        , notch_2(4)
        ),

    'uni0E29':    #SO RUSI
        packline(""
        , hf_so_rusi(70,9, 14, [55,49], 3, 1, 24,30, [67,61])
        , hr_so_rusi(71, 37,43,41, 18,35)
        , ix()
        #y
        , sy()
        , vb0s(0,15, 3)
        , vr1(37)
        , vf_no_nu(12,6, [52,46])
        , vadd_so_rusi(21,27, [64,58,35,19,38,43])
        , notch_1(58)
        , iy()
        ),

    'uni0E2A':    #SO SUA
        packline(""
        , hf_lo_ling(63,17,6, 37, 12, [60,54])
        , hr_mo_ma(64,50,24, 1)
        , add_ip(6,24,[21,4])
        , ix()
        , notch_1(23)
        , notch_2(32)
        , notch_1(48)
        #y
        , sy()
        , v0(1)
        , vtc1(41, [21,24])
        , vstem_c1(34,thin=2)
        , vb0l_head(1,15,9, [57,51])
        , vadd_lo_ling(21,4)
        , v_end_front_spline(34,37)
        , iy()
        , notch_1(43)
        , notch_2(27)
        , groove_1(24)
        , "\nf_deltap 24 16-8\n"
        ),

    'uni0E2B':    #HO HIP
        packline(""
        , hf_tho_thahan(64,15, 20,8, [49,43], 9)
        , hr_ho_hip(65,39,1, 34,28, [61,55,25,37])
        , hadd_tho_thahan(20,1, 23,6)
        , ix()
        #y
        , sy()
        , v0s(1,8)
        , vfr_ho_hip(18,31, [21], 12, [46,40,58,52,25,37], 4)
        , iy()
        , groove_1(21)
        ),

    'uni0E2C':    #LO CHULA
        packline(""
        , hf_tho_thahan(61,10, 15,3, [46,40], 4)
        , hr_lo_chula(62,36,19,1, 34, 24, [58,52,31])
        , add_ip(15,19, [17,18,2])
        , ix()
        #y
        , sy()
        , v0s(1,3)
        , vfr_lo_chula(13,7, [43,37], 27,21, [55,49,31,36])
        , add_ip(21,1, [17,2,16,19])
        , f_dstr(2,"14+4 15+4 16+4")
        , iy()
        , groove_2(2)
        , notch_1(31)
        ),

    'uni0E2D':    #O ANG
        packline(""
        , hf_o_ang(45,1,12, 23, 7, [42,36])
        , hr_ko_kai(46,30,16)
        , ix()
        #y
        , sy()
        , vb0(0,14)
        , vtc1(27)
        , vstem_c1(20,thin=1)
        , vmh_o_ang(4,10, [39,33])
        , v_end_front_spline(20,23)
        , iy()
        ),

    'uni0E2E':    #HO NOKHUK
        packline(""
        , hf_ho_nokhuk(59,1,12, 24,56, 7, [46,40])
        , hr_ho_nokhuk(60,34,16, [51,29,32,19])
        , ix()
        , notch_2(51)
        , notch_1(32)
        #y
        , sy()
        , vb0(0,14)
        , vtc1(27)
        , vstem_c1(53,thin=2)
        , vmh_ho_nokhuk(4,10, [43,37])
        , add_ip(53,4, [49,21,29,51,32,19])
        , notch_2(53)
        , notch_1(49)
        , iy()
        , notch_1(29)
        , notch_2(19)
        ),

    'uni0E2F':    #PAIYANNOI
        packline(""
        , hf_paiyannoi(36,8, 14, [33,27,17])
        , hr_mo_ma(37,23,1, 22)
        , ix()
        #y
        , sy()
        , v0(1)
        , vtc1s(11,22)
        , vadd_paiyan_noi(2, 19, [30,24,17], 5)
        , iy()
        , groove_2(2)
        ),

    'uni0E30':    #SARA A
        packline(""
        , hf_sara_a(60, 3,21, 9,27, [45,39,11,57,51,29], 15,33)
        , ix()
        #y
        , sy()
        , vm_sara_a(0, 11, 6,[42,36], 24,18, [54,48], 29)
        , iy()
        ),

    'uni0E31':    #MAI HAN-AKAT
        packline(""
        , hf_mai_hanakat(30, 3,9, [27,21], 15)
        , ix()
        #y
        , sy()
        , vm_mai_hanakat(31,30, 0,11, 6, [24,18])
        , iy()
        ),

    'uni0E32':    #SARA AA
        packline(""
        , hf_wo_waen(16,8)
        , hr_ko_kai(17,15,1)
        , ix()
        #y
        , sy()
        , v0(1)
        , vtc1(12)
        , vstem_c1(5)
        , v_end_front_spline(5,8)
        , iy()
        ),

    'uni0E34':    #SARA I
        packline(""
        , hr_sara_i(0,4, [20,14])
        , ix()
        #y
        , sy()
        , vm_sara_i(2,8,[17,12])
        , iy()
        ),

    'uni0E35':    #SARA II
        packline(""
        , hr_sara_ii(0,4, [22,16], 12)
        , ix()
        #y
        , sy()
        , vm_sara_ii(2,8, [19,14,11], 12)
        , iy()
        ),

    'uni0E36':    #SARA UE
        packline(""
        , hr_sara_ue(0,4, [31,24], 16,10, [41,35,19])
        , ix()
        #y
        , sy()
        , vm_sara_ue(2,8, [27,22], 13,19,[38,32,10])
        , iy()
        ),

    'uni0E37':    #SARA UEE
        packline(""
        , hr_sara_uee(0,4, [26,20], 16,13,11)
        , ix()
        #y
        , sy()
        , vm_sara_uee(2,8, [23,18,13,15], 11,16)
        , iy()
        ),

    'uni0E38':    #SARA U
        packline(""
        , hr_sara_u(12,1, 7, [22,18])
        , ix()
        #y
        , sy()
        , vr_sara_u(25, 10,4, [20,14], 1)
        , iy()
        ),

    'uni0E39':    #SARA UU
        packline(""
        , hr_sara_uu(16,14,11,1, 7, [27,21])
        , ix()
        #y
        , sy()
        , vr_sara_uu(31, 10,15, 4, [25,19], 14, 1)
        , iy()
        ),

    'uni0E3A':    #PHINTHU
        packline(""
        , hr_phinthu(9,3)
        , ix()
        #y
        , sy()
        , vr_phinthu(12,6,0)
        , iy()
        ),

#    'uni0E3F':    #BAHT
#        packline(""
#        , hf_baht(43,3, 23,34, 21,32,5,1, 31,20,42,7, 28,17, 39,11)
#        , ix()
#        #y
#        , sy()
#        , vm_baht(2,20, 1, 21,25, 5,8, 6, 33,42, 32,36, 22,31, 14) 
#        , iy()
#        ),
#
    'uni0E40':    #SARA E
        packline(""
        , hr_sara_e(26, 10,2, [22,16], 4)
        , ix()
        #y
        , sy()
        , v0(25)
        , vr1(4)
        , vb0l_head(25,0,7, [19,13])
        , iy()
        ),

    'uni0E42':    #SARA O
        packline(""
        , hf_ro_rua(52,6,28)
        , hr_sara_e(53,37,2, [49,43], 31)
        , ix()
        #y
        , sy()
        , v0(52)
        , vm_sara_o(10,25, 4, [6,7,28], 30)
        , vb0l_head(52,0,34, [46,40])
        , iy()
        , notch_1(7)
        ),

    'uni0E43':    #SARA AI MAIMUAN
        packline(""
        , hf_sara_ai_maimuan(66,22,16, [63,57,13], 8,28)
        , hr_sara_e(67,39,2, [51,45], 33)
        , ix()
        #y
        , sy()
        , v0(66)
        , vm_sara_ai_maimuan(25,11,13, 19, [60,54])
        , vb0l_head(66,0,36, [48,42])
        , add_ip(19,0,[3,33])
        , iy()
        ),

    'uni0E44':    #SARA AI MAIMALAI
        packline(""
        , hr_sara_e(38, 22,2, [34,28], 16)
        , hadd_sara_ai_maimalai(5,6,13, 37,9)
        , "\nf_deltap   10 15-3 10 16-3 9 15+2 9 16+2\n"
        , ix()
        #y
        , sy()
        , v0(37)
        , vm_sara_ai_maimalai(16,3, 10, 6,13)
        , vb0l_head(37,0,19, [31,25])
        , iy()
        , "\nf_deltap   14 15-3 14 16-3\n"
        ),

    'uni0E45':    #LAKHANGYAO
        packline(""
        , hf_wo_waen(16,8,g1="gap_113")
        , hr1(17,15,1,g1="gap_205")
        , ix()
        #y
        , sy()
        , v0(16)
        , vtc1(12)
        , vstem_c1(5)
        , vl0_ru(16,1)
        , v_end_front_spline(5,8)
        , iy()
        , notch_1(9)
        ),

    'uni0E46':    #MAIYAMOK
        packline(""
        ,hf_maiyamok(38,19,13,[35,29,8])
        ,hr_ko_kai(39,25,1,g1="gap_186")
        , ix()
        #y
        , sy()
        , v0(38)
        , vf_kho_khuat(23,21, 4,6, 5,22, 10,16,[32,26])
        , vl0_ru(38,1)
        , iy()
        ),

    'uni0E47':    #MAITAIKHU
        packline(""
        , hr_maitaikhu(44, 19, 38, [56,50], 11,26)
        , ix()
        #y
        , sy()
        , vm_maitaikhu(0,8, 41, [53,47,36], 31, [28,5], 22,15)
        , iy()
        ),

    'uni0E48':    #MAI EK
        packline(""
        , hr_mai_ek(0,2)
        , ix()
        #y
        , sy()
        , vm_mai_ek(0,3)
        , iy()
        ),

    'uni0E49':    #MAI THO
        packline(""
        , hr_mai_tho(14, 22, 8,2, [34,28,5,17])
        , ix()
        , dry_2(8)
        #y
        , sy()
        , vm_mai_tho(1,2, 17, 11, 5, [31,25])
        , iy()
        ),

    'uni0E4A':    #MAI TRI
        packline(""
        , hr_mai_tri(31, 35, 23, [11,5,2], 17, [47,41])
        , ix()
        #y
        , sy()
        , vm_mai_tri(20,1, 14, [44,38], 26,28, [9,7], 35)
        , iy()
        , notch_1(27)
        , notch_1(8)
        ),

    'uni0E4B':    #MAI CHATTAWA
        packline(""
        , hr_mai_chattawa(11,8, 5,2)
        , ix()
        #y
        , sy()
        , vm_mai_chattawa(0,11,2, 8,5)
        , iy()
        ),

    'uni0E4C':    #THANTHAKHAT
        packline(""
        , hr_thanthakhat(15, 9, 3, [27,21])
        , ix()
        #y
        , sy()
        , vm_thanthakhat(0,6, [24,18], 13)
        , iy()
        ),

    'uni0E4D':    #NIKKHAHIT
        packline(""
        , v0(9)
        , head_0(3, [21,15], add2=f_dstr_dict({3:"12-6 13-6 14+1 ",9:"12-2 13-2 14-1 "}))
        , f_dstr_dict({
            21:"19-1 20-1 21-1 22-1 23-1 ",
            15:"19+1 20+1 21+1 22+1 23+1 ",
            })
        , ix()
        #y
        , sy()
        , v0(0)
        , head_0(6, [18,12], add2=f_dstr_dict({6:"12+6 13+6 14-1 ",0:"12+2 13+2 14+1 "}))
        , f_dstr_dict({
            12:"19-1 20-1 21-1 22-1 23-1 ",
            18:"19+1 20+1 21+1 22+1 23+1 ",
            })
        , iy()
        ),

    'uni0E4E':    #YAMAKKAN
        packline(""
        #, hr_yamakkan(16,30, 26,0, 4, 7, 21,10)
        , hr_yamakkan(0,27, [24,16], 4, 7, 20,10)
        , ix()
        , notch_2(7)
        #y
        , sy()
        #, vm_yamakkan(0,34,26,25, 7, 18,13)
        , vm_yamakkan(0,13, [18,22,7,25,29])
        , iy()
        ),

    'uni0E4F':    #FONGMAN
        packline(""
        , hv_fongman(5,29,35,53,47,41,23,15)
        , ix()
        #y
        , sy()
        , hv_fongman(0,20,32,44,50,38,26,10)
        , iy()
        ),

    'uni0E50':    #THAI DIGIT ZERO
        packline(""
        , srp0(24)
        , mirp0rw(3,"gap_113")
        , hstem1(21)
        #
        , srp0(25)
        , mirp0rw(9,"gap_113","9+8 11+8 ")
        , hstem1(15)
        , ix()
        #y
        , sy()
        , v0(24)
        , vtc1n(6)
        , vstem_c1(18)
        , vb0lc(24,0,12)
        , iy()
        ),

    'uni0E51':    #THAI DIGIT ONE
        packline(""
        , srp0(48)
        , mirp0rw(3,"gap_113")
        , hstem1(22)
        , mdrp0mrw(33,"11-8 12-8 14-8 17-8 24-8 ")
        , h_head(33, 27, [45,39], headtype="thai_digit_one")
        #
        , srp0(49)
        , mirp0rw(9,"gap_113","9+8 10+8 ")
        , mdrprg(13,"11+8 12+8 13+8 15+8 16+8 17+8 18+8 20+8 ")
        , hstem1m(16)
        , ix()
        #y
        , sy()
        , v0(49)
        , vtc1n(6)
        , vstem_c1(19)
        , v0(49)
        , mdrpmrg(12)
        , "MDRP[min,rnd,grey]   12"
        , mdrp0rg(0)
        , vstem_c_bottom(25)
        , v_head(0, 31,[43,37], headtype="sara_a_bottom_up")
        , iy()
        ),

    'uni0E52':    #THAI DIGIT TWO
        packline(""
        , srp0(50)
        , mirp0rw(3,"gap_186","17-8 ")
        , hstem1m(8)
        , mdrp0mrw(30)
        , mdrpmrg(19)
        , h_head(30,24,[47,41],headtype="kho_khuat")
        #
        , srp0(51)
        , mirp0rw(36,"gap_113")
        , hstem1(13)
        , ix()
        #y
        , sy()
        , vb0(0,11)
        , vtc1ns(34,32)
        , vstem_c1s(15,17)
        , mdrp0mrw(21)
        , v_head(21,27,[44,38],headtype="kho_khuat")
        , iy()
        , notch_1(33)
        , notch_1(16)
        ),

    'uni0E53':    #THAI DIGIT THREE
        packline(""
        , srp0(52)
        , mirp0rw(28,"gap_113")
        , hstem1(16)
        , h_head(28,22,[49,43],headtype="thai_digit_three")
        , f_dstr_dict({ 49:"14-4 ",43:"14-4 " })
        #
        , srp0(53)
        , mirp0rw(38,"gap_113","9+8 ")
        , hstem1(3)
        , mdrp0rg(8,"11+8 12+8 23-8 27-8 29+8 ")
        , hstem1(10)
        , f_ip([33])
        , ix()
        #y
        , sy()
        , v0(1)
        , vtc1ns(35,31)
        , vstem_c1s(6,13)
        , mdrprg(9)
        , vb0l_head(1,25,19,[46,40,17])
        , f_dstr(17,"15-4 16-4 ")
        , iy()
        , groove_1(33)
        ),

    'uni0E54':    #THAI DIGIT FOUR
        packline(""
        , srp0(51)
        , mirp0rw(7,"gap_113")
        , hstem1(20)
        , mdrp0rg(27)
        , h_head(27,33,[48,42,25,36],headtype="thai_digit_four")
        , mdrprg(38,"10-8 ")
        #
        , srp0(52)
        , "ALIGNRP  14"
        , ix()
        , groove_2(25)
        , notch_1(36)
        , f_dstr_dict({
            36:"13-4 15-4 16-4 28-8 "
            })
        #y
        , sy()
        , mdap(51)
        , vtc1n(10)
        , vstem_c1(16)
        , vb0lscs(51, 4,0, 23,38)
        , mdrp0rg(30,"9-8 10-8 12-8 18-8 19-8 21-8 24-8 ")
        , v_head(30,36,[45,39],headtype="thai_digit_four")
        , iy()
        ),

    'uni0E55':    #THAI DIGIT FIVE
        packline(""
        , srp0(73)
        , mirp0rw(7,"gap_113")
        , hstem1(30)
        , mdrp0rg(37)
        , h_head(37,43,[58,52,35,46],headtype="thai_digit_four")
        , mdrprg(48,"10-8 ")
        , srp0(37)
        , mdrp0rg(12)
        , mdrprg(18,"9-8 ")
        , f_ip([70,64])
        , h_exp_head(70,64)
        #
        , srp0(74)
        , "ALIGNRP  24"
        , ix()
        , groove_2(35)
        , notch_1(46)
        , f_dstr_dict({
            46:"13-4 15-4 16-4 28-8 "
            })
        #y
        , sy()
        , mdap(73)
        , vtc1n(20)
        , vstem_c1(26)
        , mdrprg(15)
        , f_ip([67,61,10])
        , vb0lscs(73, 4,0, 33,48)
        , mdrp0rg(40,"9-8 10-8 12-8 18-8 19-8 21-8 24-8 ")
        , v_head(40,46,[55,49],headtype="thai_digit_four")
        , iy()
        ),

    'uni0E56':    #THAI DIGIT SIX
        packline(""
        , srp0(44)
        , "ALIGNRP  21" 
        , mirp0rw(19,"gap_240")
        , mdrpg(24)
        , f_dstr(24,"13-1 14-1 15-1 16-1 17+1 18+1 ")
        , mdrp0rg(3)
        , h_head(3,9,[41,35],headtype="sara_a")
        #
        , srp0(45)
        , mirp0rw(29,"gap_113","9+8 ")
        , hstem1(14)
        , ix()
        #y
        , sy()
        , mdap(44)
        , vtc1n(26)
        , vstem_c1(17)
        , mdrprg(22)
        , mdrp0rg(19)
        , mdrpg(24)
        , vb0lc(44,0,11)
        , v_head(0,6,[38,32],headtype="thai_digit_six")
        , iy()
        ),

    'uni0E57':    #THAI DIGIT SEVEN
        packline(""
        , srp0(62)
        , mirp0rw(28,"gap_113")
        , hstem1(16)
        , h_head(28,22,[59,53],headtype="thai_digit_three")
        , f_dstr_dict({ 59:"14-4 ",53:"14-4 " })
        #
        , srp0(63)
        , mirp0rw(45,"gap_164","9+8 16-8 ")
        , hstem1m(44)
        , mdrp0mrw(38)
        , hstem1(3)
        , mdrp0rg(8,"11+8 12+8 15-8 17+8 23-8 33+8 37+8 38+8 ")
        , hstem1(10)
        , f_ip([33])
        , ix()
        #y
        , sy()
        , v0(1)
        , vtc1ns(35,31)
        , mdrprg(44)
        , vstem_c1s(6,13)
        , mdrprg(9)
        , vb0l_head(1,25,19,[56,50,17])
        , f_dstr(17,"15-4 16-4 ")
        , iy()
        , groove_1(38)
        ),

    'uni0E58':    #THAI DIGIT EIGHT
        packline(""
        , srp0(52)
        , mirp0rw(6,"gap_113")
        , hstem1(19)
        , mdrp0rg(23,"9-4 ")
        , hstem1(24)
        , f_ip([2])
        , mdrp0rg(22)
        , mdrpg(3)
        #
        , srp0(53)
        , "ALIGNRP 13"
        , mirp0rw(37,"gap_152","18-8 ")
        , h_head(37,31,[49,43,28],headtype="thai_digit_one")
        , f_dstr_dict({
            49:"9+5 10+5 ",
            })
        , ix()
        , f_dstr_dict({
            25:"11-4 12-4 13-4 14-5",
            1:"15+4 ",
            })
        #y
        , sy()
        , mdap(52)
        , vtc1n(9)
        , vstem_c1(16)
        , vb0lscs(52, 3,0, 22,26)
        , v_head(0,34,[46,40],headtype="thai_digit_eight")
        , mdrp0rg(23)
        , mdrpg(2)
        , iy()
        ),


    'uni0E59':    #THAI DIGIT NINE
        packline(""
        , srp0(59)
        , mirp0rw(26,"gap_113")
        , hstem1(9)
        , mdrp0rg(20,"9-8 10-8 11-8 12-8 14-8 ")
        , h_head(20,14,[56,50,12],headtype="thai_digit_one")
        , mdrp0mrg(1,"9-8 14+8 20+8 26+8 ")
        , f_ip([31,45,3])
        , hstem1(0)
        #
        , srp0(60)
        , "ALIGNRP 38"
        , add_ip(45,38,[40,41,35])
        , ix()
        #y
        , sy()
        , mdap(1)
        , vtc1ns(33,29)
        , vstem_c1s(43,6)
        , vb0lc(1,23,12)
        , v_head(23,17,[53,47],headtype="thai_digit_nine")
        , iy()
        ),

    'uni0E5A':    #ANGKHANKHU
        packline(""
        , hf_paiyannoi(40,8, 14, [33,27,17])
        , srp0(41)
        , mirp0rw(39,"gap_205","9+8 10+8")
        , hstem1m(37)
        , mdrp0mrw(23)
        , hstem1(1)
        , "SHP[rp2] 22"
        , ix()
        #y
        , sy()
        , v0s(1,37)
        , vtc1s(11,22,[38])
        , vadd_paiyan_noi(2, 19, [30,24,17], 5)
        , iy()
        , groove_2(2)
        ),

    'uni0E5B':    #KHOMUT
        packline(""
        , srp0(70)
        , mirp0rw(3,"gap_152")
        , hstem1m(26)
        , mdrp0mrw(15)
        , mdrp0rg(9)
        , f_ip([67,61])
        , hstem1(20)
        , mdrp0mrw(32)
        #
        , srp0(71)
        , mirp0rw(45,"gap_84")
        , add_ip(32,45,[33,37,42,54,51])
        , ix()
        #y
        , sy()
        , mdap(70)
        , vtc1n(6)
        , vstem_c1(23)
        , vb0lc(70,0,29)
        , mdrp0rg(12,"9+8 10+8 18+8 ")
        , v_head(12,18,[64,58,20],headtype="bottom_up")
        , srp0(70)
        , mdrp0rg(54)
        , "ALIGNRP 51"
        , vstem_c_bottom(34)
        , "SHP[rp2] 39"
        , mdrp0rg(32)
        , "ALIGNRP 37"
        , "ALIGNRP 42"
        , mdrpmrg(55)
        , "SHP[rp2] 52"
        , "SHP[rp2] 49"
        , mdrp0rg(46)
        , vstem_b1(45)
        , iy()
        ),


    }



#++++++++++++++++++++++++++++++

if __name__ == "__main__":
    x = sys.argv
    if '--all' in x:    #find&replace in sfd file
        #$0 --all = ENCODE ALL CHARS
        sfd_file = os.path.basename(sys.argv[0]).split('.',1)[0] + '.sfd'
        print "Encoding all character in %s" % (sfd_file)
        dfont.inst_encode_all( sfd_file, pseudo_code_dict, cvt_dict )
    elif '-b' in x:   #both pseudo code & instructed code
        x.remove('-b')
        txt = pseudo_code_dict[x[1]]
        gedit(txt,1)
    else:           #instructed code
        txt = pseudo_code_dict[x[1]]
        gedit(txt)
