#!/usr/bin/env python
import os
import sys
from dttcmd import *

#----------------------------------------
#   instruction
#----------------------------------------
#hf
#----------------------------------------
def hf_0(s0,s1,add1="",g1="gap_wo_wan"):    #ro-wo-aa
    """h-front for wo_wan, ngo_ngu, ro_rua, sara_aa"""
    if g1:
        return """
SRP0                    %s              #s0
MIRP[rp0,min,rnd,white] %s %s           #g1,s1  %s  #add1
""" % (s0,g1,s1,add1)
    else:
        return """
SRP0                    %s              #s0
MDRP[rp0,min,rnd,grey]  %s              #s1     %s  #add1
""" % (s0,s1,add1)



def hf_ko_kai(s0,s1, s2,s3, s4, s5,s6, add1="", add3="", add6="", g1="gap_ko"):
    """h-front for ko_kai, tho_thung, no_nane"""
    return """
SRP0                    %s              #s0
MIRP[rp0,rnd,white]     %s %s           #g1,s1  %s  #add1
MDRP[rp0,grey]          %s              #s2
MDRP[grey]              %s              #s3     %s  #add3
SRP0                    %s              #s1
MIRP[rp0,rnd,grey]      hstem %s        #s4
MDRP[rp0,grey]          %s              #s5
MDRP[grey]              %s              #s6     %s  #add6
""" % (s0,g1,s1,add1,s2,s3,add3,s1,s4,s5,s6,add6)



def hf_kho_khwai(s0,s1,s2,s3,s4,s5,add1="",add2="",add3="",add4="",add5="",g1="gap_kho_khwai"):
    """h-front for kho_khwai, do_dek"""
    return """
SRP0                    %s              #s0
MIRP[rp0,rnd,white]     %s %s           #g1,s1  %s  #add1
MIRP[min,rnd,grey]      hstem %s        #s2     %s  #add2
MDRP[rp0,rnd,grey]      %s              #s3     %s  #add3
MIRP[min,rnd,grey]      hstem %s        #s4     %s  #add4
SRP0                    %s              #s1
MDRP[rp0,rnd,grey]      %s              #s5     %s  #add5
""" % (s0,g1,s1,add1, s2,add2, s3,add3, s4,add4, s1, s5,add5,)


#----------------------------------------
#h-rear
#----------------------------------------
def hr_1(s0,s1,s2, add1="", add2="", g1="gap_r_ko"):    #base of ko_kai
    """h-rear for ko_kai, etc"""
    return """
SRP0                    %s              #s0
MIRP[rp0,rnd,white]     %s %s           #g1,s1 %s  #add1
MIRP[min,rnd,grey]      hstem %s        #s2    %s  #add2
""" % (s0, g1, s1,add1, s2,add2)


def hr_1s(s0,s1,s2,s2s, add1="",add2="",g1="gap_r_ko"): #base of mo_ma
    """h-rear for mo_ma, etc"""
    add2 = """
SHP[rp2]                %s              #s2s
""" % (s2s,) + add2
    return hr_1(s0,s1,s2, add1,add2,g1)


#----------------------------------------
#v-top curve
#----------------------------------------
def vtc_1(s1,li=[],add1=""):
    """v-top curve for ko_kai,kho_khwai and v-front of no_nu,bo_baimai"""
    if li:
        add1 = f_ip(li)+'\n'+add1
    return """
MIRP[rp0,rnd,grey]  vheight_shoot %s    #s1         %s  #add1
""" % (s1, add1)


